# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['AppArgs', 'App']

@pulumi.input_type
class AppArgs:
    def __init__(__self__, *,
                 container_app_environment_id: pulumi.Input[str],
                 resource_group_name: pulumi.Input[str],
                 revision_mode: pulumi.Input[str],
                 template: pulumi.Input['AppTemplateArgs'],
                 dapr: Optional[pulumi.Input['AppDaprArgs']] = None,
                 identity: Optional[pulumi.Input['AppIdentityArgs']] = None,
                 ingress: Optional[pulumi.Input['AppIngressArgs']] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 registries: Optional[pulumi.Input[Sequence[pulumi.Input['AppRegistryArgs']]]] = None,
                 secrets: Optional[pulumi.Input[Sequence[pulumi.Input['AppSecretArgs']]]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None):
        """
        The set of arguments for constructing a App resource.
        :param pulumi.Input[str] container_app_environment_id: The ID of the Container App Environment within which this Container App should exist. Changing this forces a new resource to be created.
        :param pulumi.Input[str] resource_group_name: The name of the resource group in which the Container App Environment is to be created. Changing this forces a new resource to be created.
        :param pulumi.Input[str] revision_mode: The revisions operational mode for the Container App. Possible values include `Single` and `Multiple`. In `Single` mode, a single revision is in operation at any given time. In `Multiple` mode, more than one revision can be active at a time and can be configured with load distribution via the `traffic_weight` block in the `ingress` configuration.
        :param pulumi.Input['AppTemplateArgs'] template: A `template` block as detailed below.
        :param pulumi.Input['AppDaprArgs'] dapr: A `dapr` block as detailed below.
        :param pulumi.Input['AppIdentityArgs'] identity: An `identity` block as detailed below.
        :param pulumi.Input['AppIngressArgs'] ingress: An `ingress` block as detailed below.
        :param pulumi.Input[str] name: The name for this Container App. Changing this forces a new resource to be created.
        :param pulumi.Input[Sequence[pulumi.Input['AppRegistryArgs']]] registries: A `registry` block as detailed below.
        :param pulumi.Input[Sequence[pulumi.Input['AppSecretArgs']]] secrets: One or more `secret` block as detailed below.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: A mapping of tags to assign to the Container App.
        """
        AppArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            container_app_environment_id=container_app_environment_id,
            resource_group_name=resource_group_name,
            revision_mode=revision_mode,
            template=template,
            dapr=dapr,
            identity=identity,
            ingress=ingress,
            name=name,
            registries=registries,
            secrets=secrets,
            tags=tags,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             container_app_environment_id: pulumi.Input[str],
             resource_group_name: pulumi.Input[str],
             revision_mode: pulumi.Input[str],
             template: pulumi.Input['AppTemplateArgs'],
             dapr: Optional[pulumi.Input['AppDaprArgs']] = None,
             identity: Optional[pulumi.Input['AppIdentityArgs']] = None,
             ingress: Optional[pulumi.Input['AppIngressArgs']] = None,
             name: Optional[pulumi.Input[str]] = None,
             registries: Optional[pulumi.Input[Sequence[pulumi.Input['AppRegistryArgs']]]] = None,
             secrets: Optional[pulumi.Input[Sequence[pulumi.Input['AppSecretArgs']]]] = None,
             tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'containerAppEnvironmentId' in kwargs:
            container_app_environment_id = kwargs['containerAppEnvironmentId']
        if 'resourceGroupName' in kwargs:
            resource_group_name = kwargs['resourceGroupName']
        if 'revisionMode' in kwargs:
            revision_mode = kwargs['revisionMode']

        _setter("container_app_environment_id", container_app_environment_id)
        _setter("resource_group_name", resource_group_name)
        _setter("revision_mode", revision_mode)
        _setter("template", template)
        if dapr is not None:
            _setter("dapr", dapr)
        if identity is not None:
            _setter("identity", identity)
        if ingress is not None:
            _setter("ingress", ingress)
        if name is not None:
            _setter("name", name)
        if registries is not None:
            _setter("registries", registries)
        if secrets is not None:
            _setter("secrets", secrets)
        if tags is not None:
            _setter("tags", tags)

    @property
    @pulumi.getter(name="containerAppEnvironmentId")
    def container_app_environment_id(self) -> pulumi.Input[str]:
        """
        The ID of the Container App Environment within which this Container App should exist. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "container_app_environment_id")

    @container_app_environment_id.setter
    def container_app_environment_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "container_app_environment_id", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[str]:
        """
        The name of the resource group in which the Container App Environment is to be created. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="revisionMode")
    def revision_mode(self) -> pulumi.Input[str]:
        """
        The revisions operational mode for the Container App. Possible values include `Single` and `Multiple`. In `Single` mode, a single revision is in operation at any given time. In `Multiple` mode, more than one revision can be active at a time and can be configured with load distribution via the `traffic_weight` block in the `ingress` configuration.
        """
        return pulumi.get(self, "revision_mode")

    @revision_mode.setter
    def revision_mode(self, value: pulumi.Input[str]):
        pulumi.set(self, "revision_mode", value)

    @property
    @pulumi.getter
    def template(self) -> pulumi.Input['AppTemplateArgs']:
        """
        A `template` block as detailed below.
        """
        return pulumi.get(self, "template")

    @template.setter
    def template(self, value: pulumi.Input['AppTemplateArgs']):
        pulumi.set(self, "template", value)

    @property
    @pulumi.getter
    def dapr(self) -> Optional[pulumi.Input['AppDaprArgs']]:
        """
        A `dapr` block as detailed below.
        """
        return pulumi.get(self, "dapr")

    @dapr.setter
    def dapr(self, value: Optional[pulumi.Input['AppDaprArgs']]):
        pulumi.set(self, "dapr", value)

    @property
    @pulumi.getter
    def identity(self) -> Optional[pulumi.Input['AppIdentityArgs']]:
        """
        An `identity` block as detailed below.
        """
        return pulumi.get(self, "identity")

    @identity.setter
    def identity(self, value: Optional[pulumi.Input['AppIdentityArgs']]):
        pulumi.set(self, "identity", value)

    @property
    @pulumi.getter
    def ingress(self) -> Optional[pulumi.Input['AppIngressArgs']]:
        """
        An `ingress` block as detailed below.
        """
        return pulumi.get(self, "ingress")

    @ingress.setter
    def ingress(self, value: Optional[pulumi.Input['AppIngressArgs']]):
        pulumi.set(self, "ingress", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The name for this Container App. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def registries(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AppRegistryArgs']]]]:
        """
        A `registry` block as detailed below.
        """
        return pulumi.get(self, "registries")

    @registries.setter
    def registries(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AppRegistryArgs']]]]):
        pulumi.set(self, "registries", value)

    @property
    @pulumi.getter
    def secrets(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AppSecretArgs']]]]:
        """
        One or more `secret` block as detailed below.
        """
        return pulumi.get(self, "secrets")

    @secrets.setter
    def secrets(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AppSecretArgs']]]]):
        pulumi.set(self, "secrets", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        A mapping of tags to assign to the Container App.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "tags", value)


@pulumi.input_type
class _AppState:
    def __init__(__self__, *,
                 container_app_environment_id: Optional[pulumi.Input[str]] = None,
                 custom_domain_verification_id: Optional[pulumi.Input[str]] = None,
                 dapr: Optional[pulumi.Input['AppDaprArgs']] = None,
                 identity: Optional[pulumi.Input['AppIdentityArgs']] = None,
                 ingress: Optional[pulumi.Input['AppIngressArgs']] = None,
                 latest_revision_fqdn: Optional[pulumi.Input[str]] = None,
                 latest_revision_name: Optional[pulumi.Input[str]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 outbound_ip_addresses: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 registries: Optional[pulumi.Input[Sequence[pulumi.Input['AppRegistryArgs']]]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 revision_mode: Optional[pulumi.Input[str]] = None,
                 secrets: Optional[pulumi.Input[Sequence[pulumi.Input['AppSecretArgs']]]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 template: Optional[pulumi.Input['AppTemplateArgs']] = None):
        """
        Input properties used for looking up and filtering App resources.
        :param pulumi.Input[str] container_app_environment_id: The ID of the Container App Environment within which this Container App should exist. Changing this forces a new resource to be created.
        :param pulumi.Input[str] custom_domain_verification_id: The ID of the Custom Domain Verification for this Container App.
        :param pulumi.Input['AppDaprArgs'] dapr: A `dapr` block as detailed below.
        :param pulumi.Input['AppIdentityArgs'] identity: An `identity` block as detailed below.
        :param pulumi.Input['AppIngressArgs'] ingress: An `ingress` block as detailed below.
        :param pulumi.Input[str] latest_revision_fqdn: The FQDN of the Latest Revision of the Container App.
        :param pulumi.Input[str] latest_revision_name: The name of the latest Container Revision.
        :param pulumi.Input[str] location: The location this Container App is deployed in. This is the same as the Environment in which it is deployed.
        :param pulumi.Input[str] name: The name for this Container App. Changing this forces a new resource to be created.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] outbound_ip_addresses: A list of the Public IP Addresses which the Container App uses for outbound network access.
        :param pulumi.Input[Sequence[pulumi.Input['AppRegistryArgs']]] registries: A `registry` block as detailed below.
        :param pulumi.Input[str] resource_group_name: The name of the resource group in which the Container App Environment is to be created. Changing this forces a new resource to be created.
        :param pulumi.Input[str] revision_mode: The revisions operational mode for the Container App. Possible values include `Single` and `Multiple`. In `Single` mode, a single revision is in operation at any given time. In `Multiple` mode, more than one revision can be active at a time and can be configured with load distribution via the `traffic_weight` block in the `ingress` configuration.
        :param pulumi.Input[Sequence[pulumi.Input['AppSecretArgs']]] secrets: One or more `secret` block as detailed below.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: A mapping of tags to assign to the Container App.
        :param pulumi.Input['AppTemplateArgs'] template: A `template` block as detailed below.
        """
        _AppState._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            container_app_environment_id=container_app_environment_id,
            custom_domain_verification_id=custom_domain_verification_id,
            dapr=dapr,
            identity=identity,
            ingress=ingress,
            latest_revision_fqdn=latest_revision_fqdn,
            latest_revision_name=latest_revision_name,
            location=location,
            name=name,
            outbound_ip_addresses=outbound_ip_addresses,
            registries=registries,
            resource_group_name=resource_group_name,
            revision_mode=revision_mode,
            secrets=secrets,
            tags=tags,
            template=template,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             container_app_environment_id: Optional[pulumi.Input[str]] = None,
             custom_domain_verification_id: Optional[pulumi.Input[str]] = None,
             dapr: Optional[pulumi.Input['AppDaprArgs']] = None,
             identity: Optional[pulumi.Input['AppIdentityArgs']] = None,
             ingress: Optional[pulumi.Input['AppIngressArgs']] = None,
             latest_revision_fqdn: Optional[pulumi.Input[str]] = None,
             latest_revision_name: Optional[pulumi.Input[str]] = None,
             location: Optional[pulumi.Input[str]] = None,
             name: Optional[pulumi.Input[str]] = None,
             outbound_ip_addresses: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
             registries: Optional[pulumi.Input[Sequence[pulumi.Input['AppRegistryArgs']]]] = None,
             resource_group_name: Optional[pulumi.Input[str]] = None,
             revision_mode: Optional[pulumi.Input[str]] = None,
             secrets: Optional[pulumi.Input[Sequence[pulumi.Input['AppSecretArgs']]]] = None,
             tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
             template: Optional[pulumi.Input['AppTemplateArgs']] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'containerAppEnvironmentId' in kwargs:
            container_app_environment_id = kwargs['containerAppEnvironmentId']
        if 'customDomainVerificationId' in kwargs:
            custom_domain_verification_id = kwargs['customDomainVerificationId']
        if 'latestRevisionFqdn' in kwargs:
            latest_revision_fqdn = kwargs['latestRevisionFqdn']
        if 'latestRevisionName' in kwargs:
            latest_revision_name = kwargs['latestRevisionName']
        if 'outboundIpAddresses' in kwargs:
            outbound_ip_addresses = kwargs['outboundIpAddresses']
        if 'resourceGroupName' in kwargs:
            resource_group_name = kwargs['resourceGroupName']
        if 'revisionMode' in kwargs:
            revision_mode = kwargs['revisionMode']

        if container_app_environment_id is not None:
            _setter("container_app_environment_id", container_app_environment_id)
        if custom_domain_verification_id is not None:
            _setter("custom_domain_verification_id", custom_domain_verification_id)
        if dapr is not None:
            _setter("dapr", dapr)
        if identity is not None:
            _setter("identity", identity)
        if ingress is not None:
            _setter("ingress", ingress)
        if latest_revision_fqdn is not None:
            _setter("latest_revision_fqdn", latest_revision_fqdn)
        if latest_revision_name is not None:
            _setter("latest_revision_name", latest_revision_name)
        if location is not None:
            _setter("location", location)
        if name is not None:
            _setter("name", name)
        if outbound_ip_addresses is not None:
            _setter("outbound_ip_addresses", outbound_ip_addresses)
        if registries is not None:
            _setter("registries", registries)
        if resource_group_name is not None:
            _setter("resource_group_name", resource_group_name)
        if revision_mode is not None:
            _setter("revision_mode", revision_mode)
        if secrets is not None:
            _setter("secrets", secrets)
        if tags is not None:
            _setter("tags", tags)
        if template is not None:
            _setter("template", template)

    @property
    @pulumi.getter(name="containerAppEnvironmentId")
    def container_app_environment_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of the Container App Environment within which this Container App should exist. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "container_app_environment_id")

    @container_app_environment_id.setter
    def container_app_environment_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "container_app_environment_id", value)

    @property
    @pulumi.getter(name="customDomainVerificationId")
    def custom_domain_verification_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of the Custom Domain Verification for this Container App.
        """
        return pulumi.get(self, "custom_domain_verification_id")

    @custom_domain_verification_id.setter
    def custom_domain_verification_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "custom_domain_verification_id", value)

    @property
    @pulumi.getter
    def dapr(self) -> Optional[pulumi.Input['AppDaprArgs']]:
        """
        A `dapr` block as detailed below.
        """
        return pulumi.get(self, "dapr")

    @dapr.setter
    def dapr(self, value: Optional[pulumi.Input['AppDaprArgs']]):
        pulumi.set(self, "dapr", value)

    @property
    @pulumi.getter
    def identity(self) -> Optional[pulumi.Input['AppIdentityArgs']]:
        """
        An `identity` block as detailed below.
        """
        return pulumi.get(self, "identity")

    @identity.setter
    def identity(self, value: Optional[pulumi.Input['AppIdentityArgs']]):
        pulumi.set(self, "identity", value)

    @property
    @pulumi.getter
    def ingress(self) -> Optional[pulumi.Input['AppIngressArgs']]:
        """
        An `ingress` block as detailed below.
        """
        return pulumi.get(self, "ingress")

    @ingress.setter
    def ingress(self, value: Optional[pulumi.Input['AppIngressArgs']]):
        pulumi.set(self, "ingress", value)

    @property
    @pulumi.getter(name="latestRevisionFqdn")
    def latest_revision_fqdn(self) -> Optional[pulumi.Input[str]]:
        """
        The FQDN of the Latest Revision of the Container App.
        """
        return pulumi.get(self, "latest_revision_fqdn")

    @latest_revision_fqdn.setter
    def latest_revision_fqdn(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "latest_revision_fqdn", value)

    @property
    @pulumi.getter(name="latestRevisionName")
    def latest_revision_name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the latest Container Revision.
        """
        return pulumi.get(self, "latest_revision_name")

    @latest_revision_name.setter
    def latest_revision_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "latest_revision_name", value)

    @property
    @pulumi.getter
    def location(self) -> Optional[pulumi.Input[str]]:
        """
        The location this Container App is deployed in. This is the same as the Environment in which it is deployed.
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The name for this Container App. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="outboundIpAddresses")
    def outbound_ip_addresses(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        A list of the Public IP Addresses which the Container App uses for outbound network access.
        """
        return pulumi.get(self, "outbound_ip_addresses")

    @outbound_ip_addresses.setter
    def outbound_ip_addresses(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "outbound_ip_addresses", value)

    @property
    @pulumi.getter
    def registries(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AppRegistryArgs']]]]:
        """
        A `registry` block as detailed below.
        """
        return pulumi.get(self, "registries")

    @registries.setter
    def registries(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AppRegistryArgs']]]]):
        pulumi.set(self, "registries", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the resource group in which the Container App Environment is to be created. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="revisionMode")
    def revision_mode(self) -> Optional[pulumi.Input[str]]:
        """
        The revisions operational mode for the Container App. Possible values include `Single` and `Multiple`. In `Single` mode, a single revision is in operation at any given time. In `Multiple` mode, more than one revision can be active at a time and can be configured with load distribution via the `traffic_weight` block in the `ingress` configuration.
        """
        return pulumi.get(self, "revision_mode")

    @revision_mode.setter
    def revision_mode(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "revision_mode", value)

    @property
    @pulumi.getter
    def secrets(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AppSecretArgs']]]]:
        """
        One or more `secret` block as detailed below.
        """
        return pulumi.get(self, "secrets")

    @secrets.setter
    def secrets(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AppSecretArgs']]]]):
        pulumi.set(self, "secrets", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        A mapping of tags to assign to the Container App.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter
    def template(self) -> Optional[pulumi.Input['AppTemplateArgs']]:
        """
        A `template` block as detailed below.
        """
        return pulumi.get(self, "template")

    @template.setter
    def template(self, value: Optional[pulumi.Input['AppTemplateArgs']]):
        pulumi.set(self, "template", value)


class App(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 container_app_environment_id: Optional[pulumi.Input[str]] = None,
                 dapr: Optional[pulumi.Input[pulumi.InputType['AppDaprArgs']]] = None,
                 identity: Optional[pulumi.Input[pulumi.InputType['AppIdentityArgs']]] = None,
                 ingress: Optional[pulumi.Input[pulumi.InputType['AppIngressArgs']]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 registries: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AppRegistryArgs']]]]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 revision_mode: Optional[pulumi.Input[str]] = None,
                 secrets: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AppSecretArgs']]]]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 template: Optional[pulumi.Input[pulumi.InputType['AppTemplateArgs']]] = None,
                 __props__=None):
        """
        Manages a Container App.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_azure as azure

        example_resource_group = azure.core.ResourceGroup("exampleResourceGroup", location="West Europe")
        example_analytics_workspace = azure.operationalinsights.AnalyticsWorkspace("exampleAnalyticsWorkspace",
            location=example_resource_group.location,
            resource_group_name=example_resource_group.name,
            sku="PerGB2018",
            retention_in_days=30)
        example_environment = azure.containerapp.Environment("exampleEnvironment",
            location=example_resource_group.location,
            resource_group_name=example_resource_group.name,
            log_analytics_workspace_id=example_analytics_workspace.id)
        example_app = azure.containerapp.App("exampleApp",
            container_app_environment_id=example_environment.id,
            resource_group_name=example_resource_group.name,
            revision_mode="Single",
            template=azure.containerapp.AppTemplateArgs(
                containers=[azure.containerapp.AppTemplateContainerArgs(
                    name="examplecontainerapp",
                    image="mcr.microsoft.com/azuredocs/containerapps-helloworld:latest",
                    cpu=0.25,
                    memory="0.5Gi",
                )],
            ))
        ```

        ## Import

        A Container App can be imported using the `resource id`, e.g.

        ```sh
         $ pulumi import azure:containerapp/app:App example "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resGroup1/providers/Microsoft.App/containerApps/myContainerApp"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] container_app_environment_id: The ID of the Container App Environment within which this Container App should exist. Changing this forces a new resource to be created.
        :param pulumi.Input[pulumi.InputType['AppDaprArgs']] dapr: A `dapr` block as detailed below.
        :param pulumi.Input[pulumi.InputType['AppIdentityArgs']] identity: An `identity` block as detailed below.
        :param pulumi.Input[pulumi.InputType['AppIngressArgs']] ingress: An `ingress` block as detailed below.
        :param pulumi.Input[str] name: The name for this Container App. Changing this forces a new resource to be created.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AppRegistryArgs']]]] registries: A `registry` block as detailed below.
        :param pulumi.Input[str] resource_group_name: The name of the resource group in which the Container App Environment is to be created. Changing this forces a new resource to be created.
        :param pulumi.Input[str] revision_mode: The revisions operational mode for the Container App. Possible values include `Single` and `Multiple`. In `Single` mode, a single revision is in operation at any given time. In `Multiple` mode, more than one revision can be active at a time and can be configured with load distribution via the `traffic_weight` block in the `ingress` configuration.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AppSecretArgs']]]] secrets: One or more `secret` block as detailed below.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: A mapping of tags to assign to the Container App.
        :param pulumi.Input[pulumi.InputType['AppTemplateArgs']] template: A `template` block as detailed below.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: AppArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Manages a Container App.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_azure as azure

        example_resource_group = azure.core.ResourceGroup("exampleResourceGroup", location="West Europe")
        example_analytics_workspace = azure.operationalinsights.AnalyticsWorkspace("exampleAnalyticsWorkspace",
            location=example_resource_group.location,
            resource_group_name=example_resource_group.name,
            sku="PerGB2018",
            retention_in_days=30)
        example_environment = azure.containerapp.Environment("exampleEnvironment",
            location=example_resource_group.location,
            resource_group_name=example_resource_group.name,
            log_analytics_workspace_id=example_analytics_workspace.id)
        example_app = azure.containerapp.App("exampleApp",
            container_app_environment_id=example_environment.id,
            resource_group_name=example_resource_group.name,
            revision_mode="Single",
            template=azure.containerapp.AppTemplateArgs(
                containers=[azure.containerapp.AppTemplateContainerArgs(
                    name="examplecontainerapp",
                    image="mcr.microsoft.com/azuredocs/containerapps-helloworld:latest",
                    cpu=0.25,
                    memory="0.5Gi",
                )],
            ))
        ```

        ## Import

        A Container App can be imported using the `resource id`, e.g.

        ```sh
         $ pulumi import azure:containerapp/app:App example "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resGroup1/providers/Microsoft.App/containerApps/myContainerApp"
        ```

        :param str resource_name: The name of the resource.
        :param AppArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(AppArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            kwargs = kwargs or {}
            def _setter(key, value):
                kwargs[key] = value
            AppArgs._configure(_setter, **kwargs)
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 container_app_environment_id: Optional[pulumi.Input[str]] = None,
                 dapr: Optional[pulumi.Input[pulumi.InputType['AppDaprArgs']]] = None,
                 identity: Optional[pulumi.Input[pulumi.InputType['AppIdentityArgs']]] = None,
                 ingress: Optional[pulumi.Input[pulumi.InputType['AppIngressArgs']]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 registries: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AppRegistryArgs']]]]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 revision_mode: Optional[pulumi.Input[str]] = None,
                 secrets: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AppSecretArgs']]]]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 template: Optional[pulumi.Input[pulumi.InputType['AppTemplateArgs']]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = AppArgs.__new__(AppArgs)

            if container_app_environment_id is None and not opts.urn:
                raise TypeError("Missing required property 'container_app_environment_id'")
            __props__.__dict__["container_app_environment_id"] = container_app_environment_id
            if dapr is not None and not isinstance(dapr, AppDaprArgs):
                dapr = dapr or {}
                def _setter(key, value):
                    dapr[key] = value
                AppDaprArgs._configure(_setter, **dapr)
            __props__.__dict__["dapr"] = dapr
            if identity is not None and not isinstance(identity, AppIdentityArgs):
                identity = identity or {}
                def _setter(key, value):
                    identity[key] = value
                AppIdentityArgs._configure(_setter, **identity)
            __props__.__dict__["identity"] = identity
            if ingress is not None and not isinstance(ingress, AppIngressArgs):
                ingress = ingress or {}
                def _setter(key, value):
                    ingress[key] = value
                AppIngressArgs._configure(_setter, **ingress)
            __props__.__dict__["ingress"] = ingress
            __props__.__dict__["name"] = name
            __props__.__dict__["registries"] = registries
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            if revision_mode is None and not opts.urn:
                raise TypeError("Missing required property 'revision_mode'")
            __props__.__dict__["revision_mode"] = revision_mode
            __props__.__dict__["secrets"] = None if secrets is None else pulumi.Output.secret(secrets)
            __props__.__dict__["tags"] = tags
            if template is not None and not isinstance(template, AppTemplateArgs):
                template = template or {}
                def _setter(key, value):
                    template[key] = value
                AppTemplateArgs._configure(_setter, **template)
            if template is None and not opts.urn:
                raise TypeError("Missing required property 'template'")
            __props__.__dict__["template"] = template
            __props__.__dict__["custom_domain_verification_id"] = None
            __props__.__dict__["latest_revision_fqdn"] = None
            __props__.__dict__["latest_revision_name"] = None
            __props__.__dict__["location"] = None
            __props__.__dict__["outbound_ip_addresses"] = None
        secret_opts = pulumi.ResourceOptions(additional_secret_outputs=["customDomainVerificationId", "secrets"])
        opts = pulumi.ResourceOptions.merge(opts, secret_opts)
        super(App, __self__).__init__(
            'azure:containerapp/app:App',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            container_app_environment_id: Optional[pulumi.Input[str]] = None,
            custom_domain_verification_id: Optional[pulumi.Input[str]] = None,
            dapr: Optional[pulumi.Input[pulumi.InputType['AppDaprArgs']]] = None,
            identity: Optional[pulumi.Input[pulumi.InputType['AppIdentityArgs']]] = None,
            ingress: Optional[pulumi.Input[pulumi.InputType['AppIngressArgs']]] = None,
            latest_revision_fqdn: Optional[pulumi.Input[str]] = None,
            latest_revision_name: Optional[pulumi.Input[str]] = None,
            location: Optional[pulumi.Input[str]] = None,
            name: Optional[pulumi.Input[str]] = None,
            outbound_ip_addresses: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            registries: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AppRegistryArgs']]]]] = None,
            resource_group_name: Optional[pulumi.Input[str]] = None,
            revision_mode: Optional[pulumi.Input[str]] = None,
            secrets: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AppSecretArgs']]]]] = None,
            tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            template: Optional[pulumi.Input[pulumi.InputType['AppTemplateArgs']]] = None) -> 'App':
        """
        Get an existing App resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] container_app_environment_id: The ID of the Container App Environment within which this Container App should exist. Changing this forces a new resource to be created.
        :param pulumi.Input[str] custom_domain_verification_id: The ID of the Custom Domain Verification for this Container App.
        :param pulumi.Input[pulumi.InputType['AppDaprArgs']] dapr: A `dapr` block as detailed below.
        :param pulumi.Input[pulumi.InputType['AppIdentityArgs']] identity: An `identity` block as detailed below.
        :param pulumi.Input[pulumi.InputType['AppIngressArgs']] ingress: An `ingress` block as detailed below.
        :param pulumi.Input[str] latest_revision_fqdn: The FQDN of the Latest Revision of the Container App.
        :param pulumi.Input[str] latest_revision_name: The name of the latest Container Revision.
        :param pulumi.Input[str] location: The location this Container App is deployed in. This is the same as the Environment in which it is deployed.
        :param pulumi.Input[str] name: The name for this Container App. Changing this forces a new resource to be created.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] outbound_ip_addresses: A list of the Public IP Addresses which the Container App uses for outbound network access.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AppRegistryArgs']]]] registries: A `registry` block as detailed below.
        :param pulumi.Input[str] resource_group_name: The name of the resource group in which the Container App Environment is to be created. Changing this forces a new resource to be created.
        :param pulumi.Input[str] revision_mode: The revisions operational mode for the Container App. Possible values include `Single` and `Multiple`. In `Single` mode, a single revision is in operation at any given time. In `Multiple` mode, more than one revision can be active at a time and can be configured with load distribution via the `traffic_weight` block in the `ingress` configuration.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AppSecretArgs']]]] secrets: One or more `secret` block as detailed below.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: A mapping of tags to assign to the Container App.
        :param pulumi.Input[pulumi.InputType['AppTemplateArgs']] template: A `template` block as detailed below.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _AppState.__new__(_AppState)

        __props__.__dict__["container_app_environment_id"] = container_app_environment_id
        __props__.__dict__["custom_domain_verification_id"] = custom_domain_verification_id
        __props__.__dict__["dapr"] = dapr
        __props__.__dict__["identity"] = identity
        __props__.__dict__["ingress"] = ingress
        __props__.__dict__["latest_revision_fqdn"] = latest_revision_fqdn
        __props__.__dict__["latest_revision_name"] = latest_revision_name
        __props__.__dict__["location"] = location
        __props__.__dict__["name"] = name
        __props__.__dict__["outbound_ip_addresses"] = outbound_ip_addresses
        __props__.__dict__["registries"] = registries
        __props__.__dict__["resource_group_name"] = resource_group_name
        __props__.__dict__["revision_mode"] = revision_mode
        __props__.__dict__["secrets"] = secrets
        __props__.__dict__["tags"] = tags
        __props__.__dict__["template"] = template
        return App(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="containerAppEnvironmentId")
    def container_app_environment_id(self) -> pulumi.Output[str]:
        """
        The ID of the Container App Environment within which this Container App should exist. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "container_app_environment_id")

    @property
    @pulumi.getter(name="customDomainVerificationId")
    def custom_domain_verification_id(self) -> pulumi.Output[str]:
        """
        The ID of the Custom Domain Verification for this Container App.
        """
        return pulumi.get(self, "custom_domain_verification_id")

    @property
    @pulumi.getter
    def dapr(self) -> pulumi.Output[Optional['outputs.AppDapr']]:
        """
        A `dapr` block as detailed below.
        """
        return pulumi.get(self, "dapr")

    @property
    @pulumi.getter
    def identity(self) -> pulumi.Output[Optional['outputs.AppIdentity']]:
        """
        An `identity` block as detailed below.
        """
        return pulumi.get(self, "identity")

    @property
    @pulumi.getter
    def ingress(self) -> pulumi.Output[Optional['outputs.AppIngress']]:
        """
        An `ingress` block as detailed below.
        """
        return pulumi.get(self, "ingress")

    @property
    @pulumi.getter(name="latestRevisionFqdn")
    def latest_revision_fqdn(self) -> pulumi.Output[str]:
        """
        The FQDN of the Latest Revision of the Container App.
        """
        return pulumi.get(self, "latest_revision_fqdn")

    @property
    @pulumi.getter(name="latestRevisionName")
    def latest_revision_name(self) -> pulumi.Output[str]:
        """
        The name of the latest Container Revision.
        """
        return pulumi.get(self, "latest_revision_name")

    @property
    @pulumi.getter
    def location(self) -> pulumi.Output[str]:
        """
        The location this Container App is deployed in. This is the same as the Environment in which it is deployed.
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name for this Container App. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="outboundIpAddresses")
    def outbound_ip_addresses(self) -> pulumi.Output[Sequence[str]]:
        """
        A list of the Public IP Addresses which the Container App uses for outbound network access.
        """
        return pulumi.get(self, "outbound_ip_addresses")

    @property
    @pulumi.getter
    def registries(self) -> pulumi.Output[Optional[Sequence['outputs.AppRegistry']]]:
        """
        A `registry` block as detailed below.
        """
        return pulumi.get(self, "registries")

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Output[str]:
        """
        The name of the resource group in which the Container App Environment is to be created. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "resource_group_name")

    @property
    @pulumi.getter(name="revisionMode")
    def revision_mode(self) -> pulumi.Output[str]:
        """
        The revisions operational mode for the Container App. Possible values include `Single` and `Multiple`. In `Single` mode, a single revision is in operation at any given time. In `Multiple` mode, more than one revision can be active at a time and can be configured with load distribution via the `traffic_weight` block in the `ingress` configuration.
        """
        return pulumi.get(self, "revision_mode")

    @property
    @pulumi.getter
    def secrets(self) -> pulumi.Output[Optional[Sequence['outputs.AppSecret']]]:
        """
        One or more `secret` block as detailed below.
        """
        return pulumi.get(self, "secrets")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        """
        A mapping of tags to assign to the Container App.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def template(self) -> pulumi.Output['outputs.AppTemplate']:
        """
        A `template` block as detailed below.
        """
        return pulumi.get(self, "template")

