# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'GlobalVMShutdownScheduleNotificationSettingsArgs',
    'LinuxVirtualMachineGalleryImageReferenceArgs',
    'LinuxVirtualMachineInboundNatRuleArgs',
    'ScheduleDailyRecurrenceArgs',
    'ScheduleHourlyRecurrenceArgs',
    'ScheduleNotificationSettingsArgs',
    'ScheduleWeeklyRecurrenceArgs',
    'VirtualNetworkSubnetArgs',
    'WindowsVirtualMachineGalleryImageReferenceArgs',
    'WindowsVirtualMachineInboundNatRuleArgs',
]

@pulumi.input_type
class GlobalVMShutdownScheduleNotificationSettingsArgs:
    def __init__(__self__, *,
                 enabled: pulumi.Input[bool],
                 email: Optional[pulumi.Input[str]] = None,
                 time_in_minutes: Optional[pulumi.Input[int]] = None,
                 webhook_url: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[bool] enabled: Whether to enable pre-shutdown notifications. Possible values are `true` and `false`.
        :param pulumi.Input[str] email: E-mail address to which the notification will be sent.
        :param pulumi.Input[int] time_in_minutes: Time in minutes between 15 and 120 before a shutdown event at which a notification will be sent. Defaults to `30`.
        :param pulumi.Input[str] webhook_url: The webhook URL to which the notification will be sent.
        """
        GlobalVMShutdownScheduleNotificationSettingsArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            enabled=enabled,
            email=email,
            time_in_minutes=time_in_minutes,
            webhook_url=webhook_url,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             enabled: pulumi.Input[bool],
             email: Optional[pulumi.Input[str]] = None,
             time_in_minutes: Optional[pulumi.Input[int]] = None,
             webhook_url: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'timeInMinutes' in kwargs:
            time_in_minutes = kwargs['timeInMinutes']
        if 'webhookUrl' in kwargs:
            webhook_url = kwargs['webhookUrl']

        _setter("enabled", enabled)
        if email is not None:
            _setter("email", email)
        if time_in_minutes is not None:
            _setter("time_in_minutes", time_in_minutes)
        if webhook_url is not None:
            _setter("webhook_url", webhook_url)

    @property
    @pulumi.getter
    def enabled(self) -> pulumi.Input[bool]:
        """
        Whether to enable pre-shutdown notifications. Possible values are `true` and `false`.
        """
        return pulumi.get(self, "enabled")

    @enabled.setter
    def enabled(self, value: pulumi.Input[bool]):
        pulumi.set(self, "enabled", value)

    @property
    @pulumi.getter
    def email(self) -> Optional[pulumi.Input[str]]:
        """
        E-mail address to which the notification will be sent.
        """
        return pulumi.get(self, "email")

    @email.setter
    def email(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "email", value)

    @property
    @pulumi.getter(name="timeInMinutes")
    def time_in_minutes(self) -> Optional[pulumi.Input[int]]:
        """
        Time in minutes between 15 and 120 before a shutdown event at which a notification will be sent. Defaults to `30`.
        """
        return pulumi.get(self, "time_in_minutes")

    @time_in_minutes.setter
    def time_in_minutes(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "time_in_minutes", value)

    @property
    @pulumi.getter(name="webhookUrl")
    def webhook_url(self) -> Optional[pulumi.Input[str]]:
        """
        The webhook URL to which the notification will be sent.
        """
        return pulumi.get(self, "webhook_url")

    @webhook_url.setter
    def webhook_url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "webhook_url", value)


@pulumi.input_type
class LinuxVirtualMachineGalleryImageReferenceArgs:
    def __init__(__self__, *,
                 offer: pulumi.Input[str],
                 publisher: pulumi.Input[str],
                 sku: pulumi.Input[str],
                 version: pulumi.Input[str]):
        """
        :param pulumi.Input[str] offer: The Offer of the Gallery Image. Changing this forces a new resource to be created.
        :param pulumi.Input[str] publisher: The Publisher of the Gallery Image. Changing this forces a new resource to be created.
        :param pulumi.Input[str] sku: The SKU of the Gallery Image. Changing this forces a new resource to be created.
        :param pulumi.Input[str] version: The Version of the Gallery Image. Changing this forces a new resource to be created.
        """
        LinuxVirtualMachineGalleryImageReferenceArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            offer=offer,
            publisher=publisher,
            sku=sku,
            version=version,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             offer: pulumi.Input[str],
             publisher: pulumi.Input[str],
             sku: pulumi.Input[str],
             version: pulumi.Input[str],
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):

        _setter("offer", offer)
        _setter("publisher", publisher)
        _setter("sku", sku)
        _setter("version", version)

    @property
    @pulumi.getter
    def offer(self) -> pulumi.Input[str]:
        """
        The Offer of the Gallery Image. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "offer")

    @offer.setter
    def offer(self, value: pulumi.Input[str]):
        pulumi.set(self, "offer", value)

    @property
    @pulumi.getter
    def publisher(self) -> pulumi.Input[str]:
        """
        The Publisher of the Gallery Image. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "publisher")

    @publisher.setter
    def publisher(self, value: pulumi.Input[str]):
        pulumi.set(self, "publisher", value)

    @property
    @pulumi.getter
    def sku(self) -> pulumi.Input[str]:
        """
        The SKU of the Gallery Image. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "sku")

    @sku.setter
    def sku(self, value: pulumi.Input[str]):
        pulumi.set(self, "sku", value)

    @property
    @pulumi.getter
    def version(self) -> pulumi.Input[str]:
        """
        The Version of the Gallery Image. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: pulumi.Input[str]):
        pulumi.set(self, "version", value)


@pulumi.input_type
class LinuxVirtualMachineInboundNatRuleArgs:
    def __init__(__self__, *,
                 backend_port: pulumi.Input[int],
                 protocol: pulumi.Input[str],
                 frontend_port: Optional[pulumi.Input[int]] = None):
        """
        :param pulumi.Input[int] backend_port: The Backend Port associated with this NAT Rule. Changing this forces a new resource to be created.
        :param pulumi.Input[str] protocol: The Protocol used for this NAT Rule. Possible values are `Tcp` and `Udp`.
        :param pulumi.Input[int] frontend_port: The frontend port associated with this Inbound NAT Rule.
        """
        LinuxVirtualMachineInboundNatRuleArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            backend_port=backend_port,
            protocol=protocol,
            frontend_port=frontend_port,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             backend_port: pulumi.Input[int],
             protocol: pulumi.Input[str],
             frontend_port: Optional[pulumi.Input[int]] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'backendPort' in kwargs:
            backend_port = kwargs['backendPort']
        if 'frontendPort' in kwargs:
            frontend_port = kwargs['frontendPort']

        _setter("backend_port", backend_port)
        _setter("protocol", protocol)
        if frontend_port is not None:
            _setter("frontend_port", frontend_port)

    @property
    @pulumi.getter(name="backendPort")
    def backend_port(self) -> pulumi.Input[int]:
        """
        The Backend Port associated with this NAT Rule. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "backend_port")

    @backend_port.setter
    def backend_port(self, value: pulumi.Input[int]):
        pulumi.set(self, "backend_port", value)

    @property
    @pulumi.getter
    def protocol(self) -> pulumi.Input[str]:
        """
        The Protocol used for this NAT Rule. Possible values are `Tcp` and `Udp`.
        """
        return pulumi.get(self, "protocol")

    @protocol.setter
    def protocol(self, value: pulumi.Input[str]):
        pulumi.set(self, "protocol", value)

    @property
    @pulumi.getter(name="frontendPort")
    def frontend_port(self) -> Optional[pulumi.Input[int]]:
        """
        The frontend port associated with this Inbound NAT Rule.
        """
        return pulumi.get(self, "frontend_port")

    @frontend_port.setter
    def frontend_port(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "frontend_port", value)


@pulumi.input_type
class ScheduleDailyRecurrenceArgs:
    def __init__(__self__, *,
                 time: pulumi.Input[str]):
        """
        :param pulumi.Input[str] time: The time each day when the schedule takes effect.
        """
        ScheduleDailyRecurrenceArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            time=time,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             time: pulumi.Input[str],
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):

        _setter("time", time)

    @property
    @pulumi.getter
    def time(self) -> pulumi.Input[str]:
        """
        The time each day when the schedule takes effect.
        """
        return pulumi.get(self, "time")

    @time.setter
    def time(self, value: pulumi.Input[str]):
        pulumi.set(self, "time", value)


@pulumi.input_type
class ScheduleHourlyRecurrenceArgs:
    def __init__(__self__, *,
                 minute: pulumi.Input[int]):
        """
        :param pulumi.Input[int] minute: Minutes of the hour the schedule will run.
        """
        ScheduleHourlyRecurrenceArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            minute=minute,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             minute: pulumi.Input[int],
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):

        _setter("minute", minute)

    @property
    @pulumi.getter
    def minute(self) -> pulumi.Input[int]:
        """
        Minutes of the hour the schedule will run.
        """
        return pulumi.get(self, "minute")

    @minute.setter
    def minute(self, value: pulumi.Input[int]):
        pulumi.set(self, "minute", value)


@pulumi.input_type
class ScheduleNotificationSettingsArgs:
    def __init__(__self__, *,
                 status: Optional[pulumi.Input[str]] = None,
                 time_in_minutes: Optional[pulumi.Input[int]] = None,
                 webhook_url: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] status: The status of the notification. Possible values are `Enabled` and `Disabled`. Defaults to `Disabled`
        :param pulumi.Input[int] time_in_minutes: Time in minutes before event at which notification will be sent.
        :param pulumi.Input[str] webhook_url: The webhook URL to which the notification will be sent.
        """
        ScheduleNotificationSettingsArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            status=status,
            time_in_minutes=time_in_minutes,
            webhook_url=webhook_url,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             status: Optional[pulumi.Input[str]] = None,
             time_in_minutes: Optional[pulumi.Input[int]] = None,
             webhook_url: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'timeInMinutes' in kwargs:
            time_in_minutes = kwargs['timeInMinutes']
        if 'webhookUrl' in kwargs:
            webhook_url = kwargs['webhookUrl']

        if status is not None:
            _setter("status", status)
        if time_in_minutes is not None:
            _setter("time_in_minutes", time_in_minutes)
        if webhook_url is not None:
            _setter("webhook_url", webhook_url)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[str]]:
        """
        The status of the notification. Possible values are `Enabled` and `Disabled`. Defaults to `Disabled`
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "status", value)

    @property
    @pulumi.getter(name="timeInMinutes")
    def time_in_minutes(self) -> Optional[pulumi.Input[int]]:
        """
        Time in minutes before event at which notification will be sent.
        """
        return pulumi.get(self, "time_in_minutes")

    @time_in_minutes.setter
    def time_in_minutes(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "time_in_minutes", value)

    @property
    @pulumi.getter(name="webhookUrl")
    def webhook_url(self) -> Optional[pulumi.Input[str]]:
        """
        The webhook URL to which the notification will be sent.
        """
        return pulumi.get(self, "webhook_url")

    @webhook_url.setter
    def webhook_url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "webhook_url", value)


@pulumi.input_type
class ScheduleWeeklyRecurrenceArgs:
    def __init__(__self__, *,
                 time: pulumi.Input[str],
                 week_days: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        :param pulumi.Input[str] time: The time when the schedule takes effect.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] week_days: A list of days that this schedule takes effect . Possible values include `Monday`, `Tuesday`, `Wednesday`, `Thursday`, `Friday`, `Saturday` and `Sunday`.
        """
        ScheduleWeeklyRecurrenceArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            time=time,
            week_days=week_days,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             time: pulumi.Input[str],
             week_days: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'weekDays' in kwargs:
            week_days = kwargs['weekDays']

        _setter("time", time)
        if week_days is not None:
            _setter("week_days", week_days)

    @property
    @pulumi.getter
    def time(self) -> pulumi.Input[str]:
        """
        The time when the schedule takes effect.
        """
        return pulumi.get(self, "time")

    @time.setter
    def time(self, value: pulumi.Input[str]):
        pulumi.set(self, "time", value)

    @property
    @pulumi.getter(name="weekDays")
    def week_days(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        A list of days that this schedule takes effect . Possible values include `Monday`, `Tuesday`, `Wednesday`, `Thursday`, `Friday`, `Saturday` and `Sunday`.
        """
        return pulumi.get(self, "week_days")

    @week_days.setter
    def week_days(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "week_days", value)


@pulumi.input_type
class VirtualNetworkSubnetArgs:
    def __init__(__self__, *,
                 name: Optional[pulumi.Input[str]] = None,
                 use_in_virtual_machine_creation: Optional[pulumi.Input[str]] = None,
                 use_public_ip_address: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] name: Specifies the name of the Dev Test Virtual Network. Changing this forces a new resource to be created.
        :param pulumi.Input[str] use_in_virtual_machine_creation: Can this subnet be used for creating Virtual Machines? Possible values are `Allow`, `Default` and `Deny`.
        :param pulumi.Input[str] use_public_ip_address: Can Virtual Machines in this Subnet use Public IP Addresses? Possible values are `Allow`, `Default` and `Deny`.
        """
        VirtualNetworkSubnetArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            name=name,
            use_in_virtual_machine_creation=use_in_virtual_machine_creation,
            use_public_ip_address=use_public_ip_address,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             name: Optional[pulumi.Input[str]] = None,
             use_in_virtual_machine_creation: Optional[pulumi.Input[str]] = None,
             use_public_ip_address: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'useInVirtualMachineCreation' in kwargs:
            use_in_virtual_machine_creation = kwargs['useInVirtualMachineCreation']
        if 'usePublicIpAddress' in kwargs:
            use_public_ip_address = kwargs['usePublicIpAddress']

        if name is not None:
            _setter("name", name)
        if use_in_virtual_machine_creation is not None:
            _setter("use_in_virtual_machine_creation", use_in_virtual_machine_creation)
        if use_public_ip_address is not None:
            _setter("use_public_ip_address", use_public_ip_address)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the name of the Dev Test Virtual Network. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="useInVirtualMachineCreation")
    def use_in_virtual_machine_creation(self) -> Optional[pulumi.Input[str]]:
        """
        Can this subnet be used for creating Virtual Machines? Possible values are `Allow`, `Default` and `Deny`.
        """
        return pulumi.get(self, "use_in_virtual_machine_creation")

    @use_in_virtual_machine_creation.setter
    def use_in_virtual_machine_creation(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "use_in_virtual_machine_creation", value)

    @property
    @pulumi.getter(name="usePublicIpAddress")
    def use_public_ip_address(self) -> Optional[pulumi.Input[str]]:
        """
        Can Virtual Machines in this Subnet use Public IP Addresses? Possible values are `Allow`, `Default` and `Deny`.
        """
        return pulumi.get(self, "use_public_ip_address")

    @use_public_ip_address.setter
    def use_public_ip_address(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "use_public_ip_address", value)


@pulumi.input_type
class WindowsVirtualMachineGalleryImageReferenceArgs:
    def __init__(__self__, *,
                 offer: pulumi.Input[str],
                 publisher: pulumi.Input[str],
                 sku: pulumi.Input[str],
                 version: pulumi.Input[str]):
        """
        :param pulumi.Input[str] offer: The Offer of the Gallery Image. Changing this forces a new resource to be created.
        :param pulumi.Input[str] publisher: The Publisher of the Gallery Image. Changing this forces a new resource to be created.
        :param pulumi.Input[str] sku: The SKU of the Gallery Image. Changing this forces a new resource to be created.
        :param pulumi.Input[str] version: The Version of the Gallery Image. Changing this forces a new resource to be created.
        """
        WindowsVirtualMachineGalleryImageReferenceArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            offer=offer,
            publisher=publisher,
            sku=sku,
            version=version,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             offer: pulumi.Input[str],
             publisher: pulumi.Input[str],
             sku: pulumi.Input[str],
             version: pulumi.Input[str],
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):

        _setter("offer", offer)
        _setter("publisher", publisher)
        _setter("sku", sku)
        _setter("version", version)

    @property
    @pulumi.getter
    def offer(self) -> pulumi.Input[str]:
        """
        The Offer of the Gallery Image. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "offer")

    @offer.setter
    def offer(self, value: pulumi.Input[str]):
        pulumi.set(self, "offer", value)

    @property
    @pulumi.getter
    def publisher(self) -> pulumi.Input[str]:
        """
        The Publisher of the Gallery Image. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "publisher")

    @publisher.setter
    def publisher(self, value: pulumi.Input[str]):
        pulumi.set(self, "publisher", value)

    @property
    @pulumi.getter
    def sku(self) -> pulumi.Input[str]:
        """
        The SKU of the Gallery Image. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "sku")

    @sku.setter
    def sku(self, value: pulumi.Input[str]):
        pulumi.set(self, "sku", value)

    @property
    @pulumi.getter
    def version(self) -> pulumi.Input[str]:
        """
        The Version of the Gallery Image. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: pulumi.Input[str]):
        pulumi.set(self, "version", value)


@pulumi.input_type
class WindowsVirtualMachineInboundNatRuleArgs:
    def __init__(__self__, *,
                 backend_port: pulumi.Input[int],
                 protocol: pulumi.Input[str],
                 frontend_port: Optional[pulumi.Input[int]] = None):
        """
        :param pulumi.Input[int] backend_port: The Backend Port associated with this NAT Rule. Changing this forces a new resource to be created.
        :param pulumi.Input[str] protocol: The Protocol used for this NAT Rule. Possible values are `Tcp` and `Udp`.
        :param pulumi.Input[int] frontend_port: The frontend port associated with this Inbound NAT Rule.
        """
        WindowsVirtualMachineInboundNatRuleArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            backend_port=backend_port,
            protocol=protocol,
            frontend_port=frontend_port,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             backend_port: pulumi.Input[int],
             protocol: pulumi.Input[str],
             frontend_port: Optional[pulumi.Input[int]] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'backendPort' in kwargs:
            backend_port = kwargs['backendPort']
        if 'frontendPort' in kwargs:
            frontend_port = kwargs['frontendPort']

        _setter("backend_port", backend_port)
        _setter("protocol", protocol)
        if frontend_port is not None:
            _setter("frontend_port", frontend_port)

    @property
    @pulumi.getter(name="backendPort")
    def backend_port(self) -> pulumi.Input[int]:
        """
        The Backend Port associated with this NAT Rule. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "backend_port")

    @backend_port.setter
    def backend_port(self, value: pulumi.Input[int]):
        pulumi.set(self, "backend_port", value)

    @property
    @pulumi.getter
    def protocol(self) -> pulumi.Input[str]:
        """
        The Protocol used for this NAT Rule. Possible values are `Tcp` and `Udp`.
        """
        return pulumi.get(self, "protocol")

    @protocol.setter
    def protocol(self, value: pulumi.Input[str]):
        pulumi.set(self, "protocol", value)

    @property
    @pulumi.getter(name="frontendPort")
    def frontend_port(self) -> Optional[pulumi.Input[int]]:
        """
        The frontend port associated with this Inbound NAT Rule.
        """
        return pulumi.get(self, "frontend_port")

    @frontend_port.setter
    def frontend_port(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "frontend_port", value)


