# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'LinkServiceNatIpConfiguration',
    'MxRecordRecord',
    'ResolverForwardingRuleTargetDnsServer',
    'ResolverInboundEndpointIpConfiguration',
    'SRVRecordRecord',
    'TxtRecordRecord',
    'ZoneSoaRecord',
    'GetMxRecordRecordResult',
    'GetResolverForwardingRuleTargetDnsServerResult',
    'GetResolverInboundEndpointIpConfigurationResult',
    'GetSrvRecordRecordResult',
    'GetTxtRecordRecordResult',
]

@pulumi.output_type
class LinkServiceNatIpConfiguration(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "subnetId":
            suggest = "subnet_id"
        elif key == "privateIpAddress":
            suggest = "private_ip_address"
        elif key == "privateIpAddressVersion":
            suggest = "private_ip_address_version"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in LinkServiceNatIpConfiguration. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        LinkServiceNatIpConfiguration.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        LinkServiceNatIpConfiguration.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 name: str,
                 primary: bool,
                 subnet_id: str,
                 private_ip_address: Optional[str] = None,
                 private_ip_address_version: Optional[str] = None):
        """
        :param str name: Specifies the name which should be used for the NAT IP Configuration. Changing this forces a new resource to be created.
        :param bool primary: Is this is the Primary IP Configuration? Changing this forces a new resource to be created.
        :param str subnet_id: Specifies the ID of the Subnet which should be used for the Private Link Service.
               
               > **NOTE:** Verify that the Subnet's `enforce_private_link_service_network_policies` attribute is set to `true`.
        :param str private_ip_address: Specifies a Private Static IP Address for this IP Configuration.
        :param str private_ip_address_version: The version of the IP Protocol which should be used. At this time the only supported value is `IPv4`. Defaults to `IPv4`.
        """
        LinkServiceNatIpConfiguration._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            name=name,
            primary=primary,
            subnet_id=subnet_id,
            private_ip_address=private_ip_address,
            private_ip_address_version=private_ip_address_version,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             name: str,
             primary: bool,
             subnet_id: str,
             private_ip_address: Optional[str] = None,
             private_ip_address_version: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'subnetId' in kwargs:
            subnet_id = kwargs['subnetId']
        if 'privateIpAddress' in kwargs:
            private_ip_address = kwargs['privateIpAddress']
        if 'privateIpAddressVersion' in kwargs:
            private_ip_address_version = kwargs['privateIpAddressVersion']

        _setter("name", name)
        _setter("primary", primary)
        _setter("subnet_id", subnet_id)
        if private_ip_address is not None:
            _setter("private_ip_address", private_ip_address)
        if private_ip_address_version is not None:
            _setter("private_ip_address_version", private_ip_address_version)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Specifies the name which should be used for the NAT IP Configuration. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def primary(self) -> bool:
        """
        Is this is the Primary IP Configuration? Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "primary")

    @property
    @pulumi.getter(name="subnetId")
    def subnet_id(self) -> str:
        """
        Specifies the ID of the Subnet which should be used for the Private Link Service.

        > **NOTE:** Verify that the Subnet's `enforce_private_link_service_network_policies` attribute is set to `true`.
        """
        return pulumi.get(self, "subnet_id")

    @property
    @pulumi.getter(name="privateIpAddress")
    def private_ip_address(self) -> Optional[str]:
        """
        Specifies a Private Static IP Address for this IP Configuration.
        """
        return pulumi.get(self, "private_ip_address")

    @property
    @pulumi.getter(name="privateIpAddressVersion")
    def private_ip_address_version(self) -> Optional[str]:
        """
        The version of the IP Protocol which should be used. At this time the only supported value is `IPv4`. Defaults to `IPv4`.
        """
        return pulumi.get(self, "private_ip_address_version")


@pulumi.output_type
class MxRecordRecord(dict):
    def __init__(__self__, *,
                 exchange: str,
                 preference: int):
        """
        :param str exchange: The FQDN of the exchange to MX record points to.
        :param int preference: The preference of the MX record.
        """
        MxRecordRecord._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            exchange=exchange,
            preference=preference,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             exchange: str,
             preference: int,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):

        _setter("exchange", exchange)
        _setter("preference", preference)

    @property
    @pulumi.getter
    def exchange(self) -> str:
        """
        The FQDN of the exchange to MX record points to.
        """
        return pulumi.get(self, "exchange")

    @property
    @pulumi.getter
    def preference(self) -> int:
        """
        The preference of the MX record.
        """
        return pulumi.get(self, "preference")


@pulumi.output_type
class ResolverForwardingRuleTargetDnsServer(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "ipAddress":
            suggest = "ip_address"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ResolverForwardingRuleTargetDnsServer. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ResolverForwardingRuleTargetDnsServer.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ResolverForwardingRuleTargetDnsServer.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 ip_address: str,
                 port: Optional[int] = None):
        """
        :param str ip_address: DNS server IP address.
        :param int port: DNS server port.
        """
        ResolverForwardingRuleTargetDnsServer._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            ip_address=ip_address,
            port=port,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             ip_address: str,
             port: Optional[int] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'ipAddress' in kwargs:
            ip_address = kwargs['ipAddress']

        _setter("ip_address", ip_address)
        if port is not None:
            _setter("port", port)

    @property
    @pulumi.getter(name="ipAddress")
    def ip_address(self) -> str:
        """
        DNS server IP address.
        """
        return pulumi.get(self, "ip_address")

    @property
    @pulumi.getter
    def port(self) -> Optional[int]:
        """
        DNS server port.
        """
        return pulumi.get(self, "port")


@pulumi.output_type
class ResolverInboundEndpointIpConfiguration(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "subnetId":
            suggest = "subnet_id"
        elif key == "privateIpAddress":
            suggest = "private_ip_address"
        elif key == "privateIpAllocationMethod":
            suggest = "private_ip_allocation_method"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ResolverInboundEndpointIpConfiguration. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ResolverInboundEndpointIpConfiguration.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ResolverInboundEndpointIpConfiguration.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 subnet_id: str,
                 private_ip_address: Optional[str] = None,
                 private_ip_allocation_method: Optional[str] = None):
        """
        :param str subnet_id: The subnet ID of the IP configuration.
        :param str private_ip_address: Private IP address of the IP configuration.
        :param str private_ip_allocation_method: Private IP address allocation method. Allowed value is `Dynamic`. Defaults to `Dynamic`.
        """
        ResolverInboundEndpointIpConfiguration._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            subnet_id=subnet_id,
            private_ip_address=private_ip_address,
            private_ip_allocation_method=private_ip_allocation_method,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             subnet_id: str,
             private_ip_address: Optional[str] = None,
             private_ip_allocation_method: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'subnetId' in kwargs:
            subnet_id = kwargs['subnetId']
        if 'privateIpAddress' in kwargs:
            private_ip_address = kwargs['privateIpAddress']
        if 'privateIpAllocationMethod' in kwargs:
            private_ip_allocation_method = kwargs['privateIpAllocationMethod']

        _setter("subnet_id", subnet_id)
        if private_ip_address is not None:
            _setter("private_ip_address", private_ip_address)
        if private_ip_allocation_method is not None:
            _setter("private_ip_allocation_method", private_ip_allocation_method)

    @property
    @pulumi.getter(name="subnetId")
    def subnet_id(self) -> str:
        """
        The subnet ID of the IP configuration.
        """
        return pulumi.get(self, "subnet_id")

    @property
    @pulumi.getter(name="privateIpAddress")
    def private_ip_address(self) -> Optional[str]:
        """
        Private IP address of the IP configuration.
        """
        return pulumi.get(self, "private_ip_address")

    @property
    @pulumi.getter(name="privateIpAllocationMethod")
    def private_ip_allocation_method(self) -> Optional[str]:
        """
        Private IP address allocation method. Allowed value is `Dynamic`. Defaults to `Dynamic`.
        """
        return pulumi.get(self, "private_ip_allocation_method")


@pulumi.output_type
class SRVRecordRecord(dict):
    def __init__(__self__, *,
                 port: int,
                 priority: int,
                 target: str,
                 weight: int):
        """
        :param int port: The Port the service is listening on.
        :param int priority: The priority of the SRV record.
        :param str target: The FQDN of the service.
        :param int weight: The Weight of the SRV record.
        """
        SRVRecordRecord._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            port=port,
            priority=priority,
            target=target,
            weight=weight,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             port: int,
             priority: int,
             target: str,
             weight: int,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):

        _setter("port", port)
        _setter("priority", priority)
        _setter("target", target)
        _setter("weight", weight)

    @property
    @pulumi.getter
    def port(self) -> int:
        """
        The Port the service is listening on.
        """
        return pulumi.get(self, "port")

    @property
    @pulumi.getter
    def priority(self) -> int:
        """
        The priority of the SRV record.
        """
        return pulumi.get(self, "priority")

    @property
    @pulumi.getter
    def target(self) -> str:
        """
        The FQDN of the service.
        """
        return pulumi.get(self, "target")

    @property
    @pulumi.getter
    def weight(self) -> int:
        """
        The Weight of the SRV record.
        """
        return pulumi.get(self, "weight")


@pulumi.output_type
class TxtRecordRecord(dict):
    def __init__(__self__, *,
                 value: str):
        """
        :param str value: The value of the TXT record. Max length: 1024 characters
        """
        TxtRecordRecord._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            value=value,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             value: str,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):

        _setter("value", value)

    @property
    @pulumi.getter
    def value(self) -> str:
        """
        The value of the TXT record. Max length: 1024 characters
        """
        return pulumi.get(self, "value")


@pulumi.output_type
class ZoneSoaRecord(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "expireTime":
            suggest = "expire_time"
        elif key == "hostName":
            suggest = "host_name"
        elif key == "minimumTtl":
            suggest = "minimum_ttl"
        elif key == "refreshTime":
            suggest = "refresh_time"
        elif key == "retryTime":
            suggest = "retry_time"
        elif key == "serialNumber":
            suggest = "serial_number"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ZoneSoaRecord. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ZoneSoaRecord.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ZoneSoaRecord.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 email: str,
                 expire_time: Optional[int] = None,
                 fqdn: Optional[str] = None,
                 host_name: Optional[str] = None,
                 minimum_ttl: Optional[int] = None,
                 refresh_time: Optional[int] = None,
                 retry_time: Optional[int] = None,
                 serial_number: Optional[int] = None,
                 tags: Optional[Mapping[str, str]] = None,
                 ttl: Optional[int] = None):
        """
        :param str email: The email contact for the SOA record.
        :param int expire_time: The expire time for the SOA record. Defaults to `2419200`.
        :param str fqdn: The fully qualified domain name of the Record Set.
        :param str host_name: The domain name of the authoritative name server for the SOA record.
        :param int minimum_ttl: The minimum Time To Live for the SOA record. By convention, it is used to determine the negative caching duration. Defaults to `10`.
        :param int refresh_time: The refresh time for the SOA record. Defaults to `3600`.
        :param int retry_time: The retry time for the SOA record. Defaults to `300`.
        :param int serial_number: The serial number for the SOA record.
        :param Mapping[str, str] tags: A mapping of tags to assign to the Record Set.
        :param int ttl: The Time To Live of the SOA Record in seconds. Defaults to `3600`.
        """
        ZoneSoaRecord._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            email=email,
            expire_time=expire_time,
            fqdn=fqdn,
            host_name=host_name,
            minimum_ttl=minimum_ttl,
            refresh_time=refresh_time,
            retry_time=retry_time,
            serial_number=serial_number,
            tags=tags,
            ttl=ttl,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             email: str,
             expire_time: Optional[int] = None,
             fqdn: Optional[str] = None,
             host_name: Optional[str] = None,
             minimum_ttl: Optional[int] = None,
             refresh_time: Optional[int] = None,
             retry_time: Optional[int] = None,
             serial_number: Optional[int] = None,
             tags: Optional[Mapping[str, str]] = None,
             ttl: Optional[int] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'expireTime' in kwargs:
            expire_time = kwargs['expireTime']
        if 'hostName' in kwargs:
            host_name = kwargs['hostName']
        if 'minimumTtl' in kwargs:
            minimum_ttl = kwargs['minimumTtl']
        if 'refreshTime' in kwargs:
            refresh_time = kwargs['refreshTime']
        if 'retryTime' in kwargs:
            retry_time = kwargs['retryTime']
        if 'serialNumber' in kwargs:
            serial_number = kwargs['serialNumber']

        _setter("email", email)
        if expire_time is not None:
            _setter("expire_time", expire_time)
        if fqdn is not None:
            _setter("fqdn", fqdn)
        if host_name is not None:
            _setter("host_name", host_name)
        if minimum_ttl is not None:
            _setter("minimum_ttl", minimum_ttl)
        if refresh_time is not None:
            _setter("refresh_time", refresh_time)
        if retry_time is not None:
            _setter("retry_time", retry_time)
        if serial_number is not None:
            _setter("serial_number", serial_number)
        if tags is not None:
            _setter("tags", tags)
        if ttl is not None:
            _setter("ttl", ttl)

    @property
    @pulumi.getter
    def email(self) -> str:
        """
        The email contact for the SOA record.
        """
        return pulumi.get(self, "email")

    @property
    @pulumi.getter(name="expireTime")
    def expire_time(self) -> Optional[int]:
        """
        The expire time for the SOA record. Defaults to `2419200`.
        """
        return pulumi.get(self, "expire_time")

    @property
    @pulumi.getter
    def fqdn(self) -> Optional[str]:
        """
        The fully qualified domain name of the Record Set.
        """
        return pulumi.get(self, "fqdn")

    @property
    @pulumi.getter(name="hostName")
    def host_name(self) -> Optional[str]:
        """
        The domain name of the authoritative name server for the SOA record.
        """
        return pulumi.get(self, "host_name")

    @property
    @pulumi.getter(name="minimumTtl")
    def minimum_ttl(self) -> Optional[int]:
        """
        The minimum Time To Live for the SOA record. By convention, it is used to determine the negative caching duration. Defaults to `10`.
        """
        return pulumi.get(self, "minimum_ttl")

    @property
    @pulumi.getter(name="refreshTime")
    def refresh_time(self) -> Optional[int]:
        """
        The refresh time for the SOA record. Defaults to `3600`.
        """
        return pulumi.get(self, "refresh_time")

    @property
    @pulumi.getter(name="retryTime")
    def retry_time(self) -> Optional[int]:
        """
        The retry time for the SOA record. Defaults to `300`.
        """
        return pulumi.get(self, "retry_time")

    @property
    @pulumi.getter(name="serialNumber")
    def serial_number(self) -> Optional[int]:
        """
        The serial number for the SOA record.
        """
        return pulumi.get(self, "serial_number")

    @property
    @pulumi.getter
    def tags(self) -> Optional[Mapping[str, str]]:
        """
        A mapping of tags to assign to the Record Set.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def ttl(self) -> Optional[int]:
        """
        The Time To Live of the SOA Record in seconds. Defaults to `3600`.
        """
        return pulumi.get(self, "ttl")


@pulumi.output_type
class GetMxRecordRecordResult(dict):
    def __init__(__self__, *,
                 exchange: str,
                 preference: int):
        """
        :param str exchange: The mail server responsible for the domain covered by the MX record.
        :param int preference: String representing the "preference” value of the MX records. Records with lower preference value take priority.
        """
        GetMxRecordRecordResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            exchange=exchange,
            preference=preference,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             exchange: str,
             preference: int,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):

        _setter("exchange", exchange)
        _setter("preference", preference)

    @property
    @pulumi.getter
    def exchange(self) -> str:
        """
        The mail server responsible for the domain covered by the MX record.
        """
        return pulumi.get(self, "exchange")

    @property
    @pulumi.getter
    def preference(self) -> int:
        """
        String representing the "preference” value of the MX records. Records with lower preference value take priority.
        """
        return pulumi.get(self, "preference")


@pulumi.output_type
class GetResolverForwardingRuleTargetDnsServerResult(dict):
    def __init__(__self__, *,
                 ip_address: str,
                 port: int):
        """
        :param str ip_address: The DNS server IP address.
        :param int port: The DNS server port.
        """
        GetResolverForwardingRuleTargetDnsServerResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            ip_address=ip_address,
            port=port,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             ip_address: str,
             port: int,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'ipAddress' in kwargs:
            ip_address = kwargs['ipAddress']

        _setter("ip_address", ip_address)
        _setter("port", port)

    @property
    @pulumi.getter(name="ipAddress")
    def ip_address(self) -> str:
        """
        The DNS server IP address.
        """
        return pulumi.get(self, "ip_address")

    @property
    @pulumi.getter
    def port(self) -> int:
        """
        The DNS server port.
        """
        return pulumi.get(self, "port")


@pulumi.output_type
class GetResolverInboundEndpointIpConfigurationResult(dict):
    def __init__(__self__, *,
                 private_ip_address: str,
                 private_ip_allocation_method: str,
                 subnet_id: str):
        """
        :param str private_ip_address: The private IP address of the IP configuration.
        :param str private_ip_allocation_method: The private IP address allocation method.
        :param str subnet_id: The subnet ID of the IP configuration.
        """
        GetResolverInboundEndpointIpConfigurationResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            private_ip_address=private_ip_address,
            private_ip_allocation_method=private_ip_allocation_method,
            subnet_id=subnet_id,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             private_ip_address: str,
             private_ip_allocation_method: str,
             subnet_id: str,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'privateIpAddress' in kwargs:
            private_ip_address = kwargs['privateIpAddress']
        if 'privateIpAllocationMethod' in kwargs:
            private_ip_allocation_method = kwargs['privateIpAllocationMethod']
        if 'subnetId' in kwargs:
            subnet_id = kwargs['subnetId']

        _setter("private_ip_address", private_ip_address)
        _setter("private_ip_allocation_method", private_ip_allocation_method)
        _setter("subnet_id", subnet_id)

    @property
    @pulumi.getter(name="privateIpAddress")
    def private_ip_address(self) -> str:
        """
        The private IP address of the IP configuration.
        """
        return pulumi.get(self, "private_ip_address")

    @property
    @pulumi.getter(name="privateIpAllocationMethod")
    def private_ip_allocation_method(self) -> str:
        """
        The private IP address allocation method.
        """
        return pulumi.get(self, "private_ip_allocation_method")

    @property
    @pulumi.getter(name="subnetId")
    def subnet_id(self) -> str:
        """
        The subnet ID of the IP configuration.
        """
        return pulumi.get(self, "subnet_id")


@pulumi.output_type
class GetSrvRecordRecordResult(dict):
    def __init__(__self__, *,
                 port: int,
                 priority: int,
                 target: str,
                 weight: int):
        """
        :param int port: Port the service is listening on.
        :param int priority: Priority of the SRV record.
        :param str target: FQDN of the service.
        :param int weight: Weight of the SRV record.
        """
        GetSrvRecordRecordResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            port=port,
            priority=priority,
            target=target,
            weight=weight,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             port: int,
             priority: int,
             target: str,
             weight: int,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):

        _setter("port", port)
        _setter("priority", priority)
        _setter("target", target)
        _setter("weight", weight)

    @property
    @pulumi.getter
    def port(self) -> int:
        """
        Port the service is listening on.
        """
        return pulumi.get(self, "port")

    @property
    @pulumi.getter
    def priority(self) -> int:
        """
        Priority of the SRV record.
        """
        return pulumi.get(self, "priority")

    @property
    @pulumi.getter
    def target(self) -> str:
        """
        FQDN of the service.
        """
        return pulumi.get(self, "target")

    @property
    @pulumi.getter
    def weight(self) -> int:
        """
        Weight of the SRV record.
        """
        return pulumi.get(self, "weight")


@pulumi.output_type
class GetTxtRecordRecordResult(dict):
    def __init__(__self__, *,
                 value: str):
        """
        :param str value: The value of the record. Max length: 1024 characters
        """
        GetTxtRecordRecordResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            value=value,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             value: str,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):

        _setter("value", value)

    @property
    @pulumi.getter
    def value(self) -> str:
        """
        The value of the record. Max length: 1024 characters
        """
        return pulumi.get(self, "value")


