# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'PolicyCustomRule',
    'PolicyCustomRuleMatchCondition',
    'PolicyCustomRuleMatchConditionMatchVariable',
    'PolicyManagedRules',
    'PolicyManagedRulesExclusion',
    'PolicyManagedRulesExclusionExcludedRuleSet',
    'PolicyManagedRulesExclusionExcludedRuleSetRuleGroup',
    'PolicyManagedRulesManagedRuleSet',
    'PolicyManagedRulesManagedRuleSetRuleGroupOverride',
    'PolicyManagedRulesManagedRuleSetRuleGroupOverrideRule',
    'PolicyPolicySettings',
    'PolicyPolicySettingsLogScrubbing',
    'PolicyPolicySettingsLogScrubbingRule',
]

@pulumi.output_type
class PolicyCustomRule(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "matchConditions":
            suggest = "match_conditions"
        elif key == "ruleType":
            suggest = "rule_type"
        elif key == "groupRateLimitBy":
            suggest = "group_rate_limit_by"
        elif key == "rateLimitDuration":
            suggest = "rate_limit_duration"
        elif key == "rateLimitThreshold":
            suggest = "rate_limit_threshold"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in PolicyCustomRule. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        PolicyCustomRule.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        PolicyCustomRule.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 action: str,
                 match_conditions: Sequence['outputs.PolicyCustomRuleMatchCondition'],
                 priority: int,
                 rule_type: str,
                 enabled: Optional[bool] = None,
                 group_rate_limit_by: Optional[str] = None,
                 name: Optional[str] = None,
                 rate_limit_duration: Optional[str] = None,
                 rate_limit_threshold: Optional[int] = None):
        """
        :param str action: Type of action. Possible values are `Allow`, `Block` and `Log`.
        :param Sequence['PolicyCustomRuleMatchConditionArgs'] match_conditions: One or more `match_conditions` blocks as defined below.
        :param int priority: Describes priority of the rule. Rules with a lower value will be evaluated before rules with a higher value.
        :param str rule_type: Describes the type of rule. Possible values are `MatchRule`, `RateLimitRule` and `Invalid`.
        :param bool enabled: Describes if the policy is in enabled state or disabled state. Defaults to `true`.
        :param str group_rate_limit_by: Specifies what grouping the rate limit will count requests by. Possible values are `GeoLocation`, `ClientAddr` and `None`.
        :param str name: Gets name of the resource that is unique within a policy. This name can be used to access the resource.
        :param str rate_limit_duration: Specifies the duration at which the rate limit policy will be applied. Should be used with `RateLimitRule` rule type. Possible values are `FiveMins` and `OneMin`.
        :param int rate_limit_threshold: Specifies the threshold value for the rate limit policy. Must be greater than or equal to 1 if provided.
        """
        PolicyCustomRule._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            action=action,
            match_conditions=match_conditions,
            priority=priority,
            rule_type=rule_type,
            enabled=enabled,
            group_rate_limit_by=group_rate_limit_by,
            name=name,
            rate_limit_duration=rate_limit_duration,
            rate_limit_threshold=rate_limit_threshold,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             action: str,
             match_conditions: Sequence['outputs.PolicyCustomRuleMatchCondition'],
             priority: int,
             rule_type: str,
             enabled: Optional[bool] = None,
             group_rate_limit_by: Optional[str] = None,
             name: Optional[str] = None,
             rate_limit_duration: Optional[str] = None,
             rate_limit_threshold: Optional[int] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'matchConditions' in kwargs:
            match_conditions = kwargs['matchConditions']
        if 'ruleType' in kwargs:
            rule_type = kwargs['ruleType']
        if 'groupRateLimitBy' in kwargs:
            group_rate_limit_by = kwargs['groupRateLimitBy']
        if 'rateLimitDuration' in kwargs:
            rate_limit_duration = kwargs['rateLimitDuration']
        if 'rateLimitThreshold' in kwargs:
            rate_limit_threshold = kwargs['rateLimitThreshold']

        _setter("action", action)
        _setter("match_conditions", match_conditions)
        _setter("priority", priority)
        _setter("rule_type", rule_type)
        if enabled is not None:
            _setter("enabled", enabled)
        if group_rate_limit_by is not None:
            _setter("group_rate_limit_by", group_rate_limit_by)
        if name is not None:
            _setter("name", name)
        if rate_limit_duration is not None:
            _setter("rate_limit_duration", rate_limit_duration)
        if rate_limit_threshold is not None:
            _setter("rate_limit_threshold", rate_limit_threshold)

    @property
    @pulumi.getter
    def action(self) -> str:
        """
        Type of action. Possible values are `Allow`, `Block` and `Log`.
        """
        return pulumi.get(self, "action")

    @property
    @pulumi.getter(name="matchConditions")
    def match_conditions(self) -> Sequence['outputs.PolicyCustomRuleMatchCondition']:
        """
        One or more `match_conditions` blocks as defined below.
        """
        return pulumi.get(self, "match_conditions")

    @property
    @pulumi.getter
    def priority(self) -> int:
        """
        Describes priority of the rule. Rules with a lower value will be evaluated before rules with a higher value.
        """
        return pulumi.get(self, "priority")

    @property
    @pulumi.getter(name="ruleType")
    def rule_type(self) -> str:
        """
        Describes the type of rule. Possible values are `MatchRule`, `RateLimitRule` and `Invalid`.
        """
        return pulumi.get(self, "rule_type")

    @property
    @pulumi.getter
    def enabled(self) -> Optional[bool]:
        """
        Describes if the policy is in enabled state or disabled state. Defaults to `true`.
        """
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter(name="groupRateLimitBy")
    def group_rate_limit_by(self) -> Optional[str]:
        """
        Specifies what grouping the rate limit will count requests by. Possible values are `GeoLocation`, `ClientAddr` and `None`.
        """
        return pulumi.get(self, "group_rate_limit_by")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        Gets name of the resource that is unique within a policy. This name can be used to access the resource.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="rateLimitDuration")
    def rate_limit_duration(self) -> Optional[str]:
        """
        Specifies the duration at which the rate limit policy will be applied. Should be used with `RateLimitRule` rule type. Possible values are `FiveMins` and `OneMin`.
        """
        return pulumi.get(self, "rate_limit_duration")

    @property
    @pulumi.getter(name="rateLimitThreshold")
    def rate_limit_threshold(self) -> Optional[int]:
        """
        Specifies the threshold value for the rate limit policy. Must be greater than or equal to 1 if provided.
        """
        return pulumi.get(self, "rate_limit_threshold")


@pulumi.output_type
class PolicyCustomRuleMatchCondition(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "matchVariables":
            suggest = "match_variables"
        elif key == "matchValues":
            suggest = "match_values"
        elif key == "negationCondition":
            suggest = "negation_condition"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in PolicyCustomRuleMatchCondition. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        PolicyCustomRuleMatchCondition.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        PolicyCustomRuleMatchCondition.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 match_variables: Sequence['outputs.PolicyCustomRuleMatchConditionMatchVariable'],
                 operator: str,
                 match_values: Optional[Sequence[str]] = None,
                 negation_condition: Optional[bool] = None,
                 transforms: Optional[Sequence[str]] = None):
        """
        :param Sequence['PolicyCustomRuleMatchConditionMatchVariableArgs'] match_variables: One or more `match_variables` blocks as defined below.
        :param str operator: Describes operator to be matched. Possible values are `Any`, `IPMatch`, `GeoMatch`, `Equal`, `Contains`, `LessThan`, `GreaterThan`, `LessThanOrEqual`, `GreaterThanOrEqual`, `BeginsWith`, `EndsWith` and `Regex`.
        :param Sequence[str] match_values: A list of match values. This is **Required** when the `operator` is not `Any`.
        :param bool negation_condition: Describes if this is negate condition or not
        :param Sequence[str] transforms: A list of transformations to do before the match is attempted. Possible values are `HtmlEntityDecode`, `Lowercase`, `RemoveNulls`, `Trim`, `UrlDecode` and `UrlEncode`.
        """
        PolicyCustomRuleMatchCondition._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            match_variables=match_variables,
            operator=operator,
            match_values=match_values,
            negation_condition=negation_condition,
            transforms=transforms,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             match_variables: Sequence['outputs.PolicyCustomRuleMatchConditionMatchVariable'],
             operator: str,
             match_values: Optional[Sequence[str]] = None,
             negation_condition: Optional[bool] = None,
             transforms: Optional[Sequence[str]] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'matchVariables' in kwargs:
            match_variables = kwargs['matchVariables']
        if 'matchValues' in kwargs:
            match_values = kwargs['matchValues']
        if 'negationCondition' in kwargs:
            negation_condition = kwargs['negationCondition']

        _setter("match_variables", match_variables)
        _setter("operator", operator)
        if match_values is not None:
            _setter("match_values", match_values)
        if negation_condition is not None:
            _setter("negation_condition", negation_condition)
        if transforms is not None:
            _setter("transforms", transforms)

    @property
    @pulumi.getter(name="matchVariables")
    def match_variables(self) -> Sequence['outputs.PolicyCustomRuleMatchConditionMatchVariable']:
        """
        One or more `match_variables` blocks as defined below.
        """
        return pulumi.get(self, "match_variables")

    @property
    @pulumi.getter
    def operator(self) -> str:
        """
        Describes operator to be matched. Possible values are `Any`, `IPMatch`, `GeoMatch`, `Equal`, `Contains`, `LessThan`, `GreaterThan`, `LessThanOrEqual`, `GreaterThanOrEqual`, `BeginsWith`, `EndsWith` and `Regex`.
        """
        return pulumi.get(self, "operator")

    @property
    @pulumi.getter(name="matchValues")
    def match_values(self) -> Optional[Sequence[str]]:
        """
        A list of match values. This is **Required** when the `operator` is not `Any`.
        """
        return pulumi.get(self, "match_values")

    @property
    @pulumi.getter(name="negationCondition")
    def negation_condition(self) -> Optional[bool]:
        """
        Describes if this is negate condition or not
        """
        return pulumi.get(self, "negation_condition")

    @property
    @pulumi.getter
    def transforms(self) -> Optional[Sequence[str]]:
        """
        A list of transformations to do before the match is attempted. Possible values are `HtmlEntityDecode`, `Lowercase`, `RemoveNulls`, `Trim`, `UrlDecode` and `UrlEncode`.
        """
        return pulumi.get(self, "transforms")


@pulumi.output_type
class PolicyCustomRuleMatchConditionMatchVariable(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "variableName":
            suggest = "variable_name"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in PolicyCustomRuleMatchConditionMatchVariable. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        PolicyCustomRuleMatchConditionMatchVariable.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        PolicyCustomRuleMatchConditionMatchVariable.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 variable_name: str,
                 selector: Optional[str] = None):
        """
        :param str variable_name: The name of the Match Variable. Possible values are `RemoteAddr`, `RequestMethod`, `QueryString`, `PostArgs`, `RequestUri`, `RequestHeaders`, `RequestBody` and `RequestCookies`.
        :param str selector: Describes field of the matchVariable collection
        """
        PolicyCustomRuleMatchConditionMatchVariable._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            variable_name=variable_name,
            selector=selector,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             variable_name: str,
             selector: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'variableName' in kwargs:
            variable_name = kwargs['variableName']

        _setter("variable_name", variable_name)
        if selector is not None:
            _setter("selector", selector)

    @property
    @pulumi.getter(name="variableName")
    def variable_name(self) -> str:
        """
        The name of the Match Variable. Possible values are `RemoteAddr`, `RequestMethod`, `QueryString`, `PostArgs`, `RequestUri`, `RequestHeaders`, `RequestBody` and `RequestCookies`.
        """
        return pulumi.get(self, "variable_name")

    @property
    @pulumi.getter
    def selector(self) -> Optional[str]:
        """
        Describes field of the matchVariable collection
        """
        return pulumi.get(self, "selector")


@pulumi.output_type
class PolicyManagedRules(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "managedRuleSets":
            suggest = "managed_rule_sets"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in PolicyManagedRules. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        PolicyManagedRules.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        PolicyManagedRules.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 managed_rule_sets: Sequence['outputs.PolicyManagedRulesManagedRuleSet'],
                 exclusions: Optional[Sequence['outputs.PolicyManagedRulesExclusion']] = None):
        """
        :param Sequence['PolicyManagedRulesManagedRuleSetArgs'] managed_rule_sets: One or more `managed_rule_set` block defined below.
        :param Sequence['PolicyManagedRulesExclusionArgs'] exclusions: One or more `exclusion` block defined below.
        """
        PolicyManagedRules._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            managed_rule_sets=managed_rule_sets,
            exclusions=exclusions,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             managed_rule_sets: Sequence['outputs.PolicyManagedRulesManagedRuleSet'],
             exclusions: Optional[Sequence['outputs.PolicyManagedRulesExclusion']] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'managedRuleSets' in kwargs:
            managed_rule_sets = kwargs['managedRuleSets']

        _setter("managed_rule_sets", managed_rule_sets)
        if exclusions is not None:
            _setter("exclusions", exclusions)

    @property
    @pulumi.getter(name="managedRuleSets")
    def managed_rule_sets(self) -> Sequence['outputs.PolicyManagedRulesManagedRuleSet']:
        """
        One or more `managed_rule_set` block defined below.
        """
        return pulumi.get(self, "managed_rule_sets")

    @property
    @pulumi.getter
    def exclusions(self) -> Optional[Sequence['outputs.PolicyManagedRulesExclusion']]:
        """
        One or more `exclusion` block defined below.
        """
        return pulumi.get(self, "exclusions")


@pulumi.output_type
class PolicyManagedRulesExclusion(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "matchVariable":
            suggest = "match_variable"
        elif key == "selectorMatchOperator":
            suggest = "selector_match_operator"
        elif key == "excludedRuleSet":
            suggest = "excluded_rule_set"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in PolicyManagedRulesExclusion. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        PolicyManagedRulesExclusion.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        PolicyManagedRulesExclusion.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 match_variable: str,
                 selector: str,
                 selector_match_operator: str,
                 excluded_rule_set: Optional['outputs.PolicyManagedRulesExclusionExcludedRuleSet'] = None):
        """
        :param str match_variable: The name of the Match Variable. Possible values: `RequestArgKeys`, `RequestArgNames`, `RequestArgValues`, `RequestCookieKeys`, `RequestCookieNames`, `RequestCookieValues`, `RequestHeaderKeys`, `RequestHeaderNames`, `RequestHeaderValues`.
        :param str selector: Describes field of the matchVariable collection.
        :param str selector_match_operator: Describes operator to be matched. Possible values: `Contains`, `EndsWith`, `Equals`, `EqualsAny`, `StartsWith`.
        :param 'PolicyManagedRulesExclusionExcludedRuleSetArgs' excluded_rule_set: One or more `excluded_rule_set` block defined below.
        """
        PolicyManagedRulesExclusion._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            match_variable=match_variable,
            selector=selector,
            selector_match_operator=selector_match_operator,
            excluded_rule_set=excluded_rule_set,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             match_variable: str,
             selector: str,
             selector_match_operator: str,
             excluded_rule_set: Optional['outputs.PolicyManagedRulesExclusionExcludedRuleSet'] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'matchVariable' in kwargs:
            match_variable = kwargs['matchVariable']
        if 'selectorMatchOperator' in kwargs:
            selector_match_operator = kwargs['selectorMatchOperator']
        if 'excludedRuleSet' in kwargs:
            excluded_rule_set = kwargs['excludedRuleSet']

        _setter("match_variable", match_variable)
        _setter("selector", selector)
        _setter("selector_match_operator", selector_match_operator)
        if excluded_rule_set is not None:
            _setter("excluded_rule_set", excluded_rule_set)

    @property
    @pulumi.getter(name="matchVariable")
    def match_variable(self) -> str:
        """
        The name of the Match Variable. Possible values: `RequestArgKeys`, `RequestArgNames`, `RequestArgValues`, `RequestCookieKeys`, `RequestCookieNames`, `RequestCookieValues`, `RequestHeaderKeys`, `RequestHeaderNames`, `RequestHeaderValues`.
        """
        return pulumi.get(self, "match_variable")

    @property
    @pulumi.getter
    def selector(self) -> str:
        """
        Describes field of the matchVariable collection.
        """
        return pulumi.get(self, "selector")

    @property
    @pulumi.getter(name="selectorMatchOperator")
    def selector_match_operator(self) -> str:
        """
        Describes operator to be matched. Possible values: `Contains`, `EndsWith`, `Equals`, `EqualsAny`, `StartsWith`.
        """
        return pulumi.get(self, "selector_match_operator")

    @property
    @pulumi.getter(name="excludedRuleSet")
    def excluded_rule_set(self) -> Optional['outputs.PolicyManagedRulesExclusionExcludedRuleSet']:
        """
        One or more `excluded_rule_set` block defined below.
        """
        return pulumi.get(self, "excluded_rule_set")


@pulumi.output_type
class PolicyManagedRulesExclusionExcludedRuleSet(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "ruleGroups":
            suggest = "rule_groups"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in PolicyManagedRulesExclusionExcludedRuleSet. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        PolicyManagedRulesExclusionExcludedRuleSet.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        PolicyManagedRulesExclusionExcludedRuleSet.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 rule_groups: Optional[Sequence['outputs.PolicyManagedRulesExclusionExcludedRuleSetRuleGroup']] = None,
                 type: Optional[str] = None,
                 version: Optional[str] = None):
        """
        :param Sequence['PolicyManagedRulesExclusionExcludedRuleSetRuleGroupArgs'] rule_groups: One or more `rule_group` block defined below.
        :param str type: The rule set type. The only possible value is `OWASP` . Defaults to `OWASP`.
        :param str version: The rule set version. The only possible value is `3.2` . Defaults to `3.2`.
        """
        PolicyManagedRulesExclusionExcludedRuleSet._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            rule_groups=rule_groups,
            type=type,
            version=version,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             rule_groups: Optional[Sequence['outputs.PolicyManagedRulesExclusionExcludedRuleSetRuleGroup']] = None,
             type: Optional[str] = None,
             version: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'ruleGroups' in kwargs:
            rule_groups = kwargs['ruleGroups']

        if rule_groups is not None:
            _setter("rule_groups", rule_groups)
        if type is not None:
            _setter("type", type)
        if version is not None:
            _setter("version", version)

    @property
    @pulumi.getter(name="ruleGroups")
    def rule_groups(self) -> Optional[Sequence['outputs.PolicyManagedRulesExclusionExcludedRuleSetRuleGroup']]:
        """
        One or more `rule_group` block defined below.
        """
        return pulumi.get(self, "rule_groups")

    @property
    @pulumi.getter
    def type(self) -> Optional[str]:
        """
        The rule set type. The only possible value is `OWASP` . Defaults to `OWASP`.
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter
    def version(self) -> Optional[str]:
        """
        The rule set version. The only possible value is `3.2` . Defaults to `3.2`.
        """
        return pulumi.get(self, "version")


@pulumi.output_type
class PolicyManagedRulesExclusionExcludedRuleSetRuleGroup(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "ruleGroupName":
            suggest = "rule_group_name"
        elif key == "excludedRules":
            suggest = "excluded_rules"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in PolicyManagedRulesExclusionExcludedRuleSetRuleGroup. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        PolicyManagedRulesExclusionExcludedRuleSetRuleGroup.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        PolicyManagedRulesExclusionExcludedRuleSetRuleGroup.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 rule_group_name: str,
                 excluded_rules: Optional[Sequence[str]] = None):
        """
        :param str rule_group_name: The name of rule group for exclusion. Possible values are `BadBots`, `crs_20_protocol_violations`, `crs_21_protocol_anomalies`, `crs_23_request_limits`, `crs_30_http_policy`, `crs_35_bad_robots`, `crs_40_generic_attacks`, `crs_41_sql_injection_attacks`, `crs_41_xss_attacks`, `crs_42_tight_security`, `crs_45_trojans`, `General`, `GoodBots`, `Known-CVEs`, `REQUEST-911-METHOD-ENFORCEMENT`, `REQUEST-913-SCANNER-DETECTION`, `REQUEST-920-PROTOCOL-ENFORCEMENT`, `REQUEST-921-PROTOCOL-ATTACK`, `REQUEST-930-APPLICATION-ATTACK-LFI`, `REQUEST-931-APPLICATION-ATTACK-RFI`, `REQUEST-932-APPLICATION-ATTACK-RCE`, `REQUEST-933-APPLICATION-ATTACK-PHP`, `REQUEST-941-APPLICATION-ATTACK-XSS`, `REQUEST-942-APPLICATION-ATTACK-SQLI`, `REQUEST-943-APPLICATION-ATTACK-SESSION-FIXATION`, `REQUEST-944-APPLICATION-ATTACK-JAVA` and `UnknownBots`.
        :param Sequence[str] excluded_rules: One or more Rule IDs for exclusion.
        """
        PolicyManagedRulesExclusionExcludedRuleSetRuleGroup._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            rule_group_name=rule_group_name,
            excluded_rules=excluded_rules,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             rule_group_name: str,
             excluded_rules: Optional[Sequence[str]] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'ruleGroupName' in kwargs:
            rule_group_name = kwargs['ruleGroupName']
        if 'excludedRules' in kwargs:
            excluded_rules = kwargs['excludedRules']

        _setter("rule_group_name", rule_group_name)
        if excluded_rules is not None:
            _setter("excluded_rules", excluded_rules)

    @property
    @pulumi.getter(name="ruleGroupName")
    def rule_group_name(self) -> str:
        """
        The name of rule group for exclusion. Possible values are `BadBots`, `crs_20_protocol_violations`, `crs_21_protocol_anomalies`, `crs_23_request_limits`, `crs_30_http_policy`, `crs_35_bad_robots`, `crs_40_generic_attacks`, `crs_41_sql_injection_attacks`, `crs_41_xss_attacks`, `crs_42_tight_security`, `crs_45_trojans`, `General`, `GoodBots`, `Known-CVEs`, `REQUEST-911-METHOD-ENFORCEMENT`, `REQUEST-913-SCANNER-DETECTION`, `REQUEST-920-PROTOCOL-ENFORCEMENT`, `REQUEST-921-PROTOCOL-ATTACK`, `REQUEST-930-APPLICATION-ATTACK-LFI`, `REQUEST-931-APPLICATION-ATTACK-RFI`, `REQUEST-932-APPLICATION-ATTACK-RCE`, `REQUEST-933-APPLICATION-ATTACK-PHP`, `REQUEST-941-APPLICATION-ATTACK-XSS`, `REQUEST-942-APPLICATION-ATTACK-SQLI`, `REQUEST-943-APPLICATION-ATTACK-SESSION-FIXATION`, `REQUEST-944-APPLICATION-ATTACK-JAVA` and `UnknownBots`.
        """
        return pulumi.get(self, "rule_group_name")

    @property
    @pulumi.getter(name="excludedRules")
    def excluded_rules(self) -> Optional[Sequence[str]]:
        """
        One or more Rule IDs for exclusion.
        """
        return pulumi.get(self, "excluded_rules")


@pulumi.output_type
class PolicyManagedRulesManagedRuleSet(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "ruleGroupOverrides":
            suggest = "rule_group_overrides"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in PolicyManagedRulesManagedRuleSet. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        PolicyManagedRulesManagedRuleSet.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        PolicyManagedRulesManagedRuleSet.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 version: str,
                 rule_group_overrides: Optional[Sequence['outputs.PolicyManagedRulesManagedRuleSetRuleGroupOverride']] = None,
                 type: Optional[str] = None):
        """
        :param str version: The rule set version. Possible values: `0.1`, `1.0`, `2.2.9`, `3.0`, `3.1` and `3.2`.
        :param Sequence['PolicyManagedRulesManagedRuleSetRuleGroupOverrideArgs'] rule_group_overrides: One or more `rule_group_override` block defined below.
        :param str type: The rule set type. Possible values: `Microsoft_BotManagerRuleSet` and `OWASP`.
        """
        PolicyManagedRulesManagedRuleSet._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            version=version,
            rule_group_overrides=rule_group_overrides,
            type=type,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             version: str,
             rule_group_overrides: Optional[Sequence['outputs.PolicyManagedRulesManagedRuleSetRuleGroupOverride']] = None,
             type: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'ruleGroupOverrides' in kwargs:
            rule_group_overrides = kwargs['ruleGroupOverrides']

        _setter("version", version)
        if rule_group_overrides is not None:
            _setter("rule_group_overrides", rule_group_overrides)
        if type is not None:
            _setter("type", type)

    @property
    @pulumi.getter
    def version(self) -> str:
        """
        The rule set version. Possible values: `0.1`, `1.0`, `2.2.9`, `3.0`, `3.1` and `3.2`.
        """
        return pulumi.get(self, "version")

    @property
    @pulumi.getter(name="ruleGroupOverrides")
    def rule_group_overrides(self) -> Optional[Sequence['outputs.PolicyManagedRulesManagedRuleSetRuleGroupOverride']]:
        """
        One or more `rule_group_override` block defined below.
        """
        return pulumi.get(self, "rule_group_overrides")

    @property
    @pulumi.getter
    def type(self) -> Optional[str]:
        """
        The rule set type. Possible values: `Microsoft_BotManagerRuleSet` and `OWASP`.
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class PolicyManagedRulesManagedRuleSetRuleGroupOverride(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "ruleGroupName":
            suggest = "rule_group_name"
        elif key == "disabledRules":
            suggest = "disabled_rules"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in PolicyManagedRulesManagedRuleSetRuleGroupOverride. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        PolicyManagedRulesManagedRuleSetRuleGroupOverride.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        PolicyManagedRulesManagedRuleSetRuleGroupOverride.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 rule_group_name: str,
                 disabled_rules: Optional[Sequence[str]] = None,
                 rules: Optional[Sequence['outputs.PolicyManagedRulesManagedRuleSetRuleGroupOverrideRule']] = None):
        """
        :param str rule_group_name: The name of the Rule Group. Possible values are `BadBots`, `crs_20_protocol_violations`, `crs_21_protocol_anomalies`, `crs_23_request_limits`, `crs_30_http_policy`, `crs_35_bad_robots`, `crs_40_generic_attacks`, `crs_41_sql_injection_attacks`, `crs_41_xss_attacks`, `crs_42_tight_security`, `crs_45_trojans`, `General`, `GoodBots`, `Known-CVEs`, `REQUEST-911-METHOD-ENFORCEMENT`, `REQUEST-913-SCANNER-DETECTION`, `REQUEST-920-PROTOCOL-ENFORCEMENT`, `REQUEST-921-PROTOCOL-ATTACK`, `REQUEST-930-APPLICATION-ATTACK-LFI`, `REQUEST-931-APPLICATION-ATTACK-RFI`, `REQUEST-932-APPLICATION-ATTACK-RCE`, `REQUEST-933-APPLICATION-ATTACK-PHP`, `REQUEST-941-APPLICATION-ATTACK-XSS`, `REQUEST-942-APPLICATION-ATTACK-SQLI`, `REQUEST-943-APPLICATION-ATTACK-SESSION-FIXATION`, `REQUEST-944-APPLICATION-ATTACK-JAVA` and `UnknownBots`.
        :param Sequence['PolicyManagedRulesManagedRuleSetRuleGroupOverrideRuleArgs'] rules: One or more `rule` block defined below.
        """
        PolicyManagedRulesManagedRuleSetRuleGroupOverride._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            rule_group_name=rule_group_name,
            disabled_rules=disabled_rules,
            rules=rules,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             rule_group_name: str,
             disabled_rules: Optional[Sequence[str]] = None,
             rules: Optional[Sequence['outputs.PolicyManagedRulesManagedRuleSetRuleGroupOverrideRule']] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'ruleGroupName' in kwargs:
            rule_group_name = kwargs['ruleGroupName']
        if 'disabledRules' in kwargs:
            disabled_rules = kwargs['disabledRules']

        _setter("rule_group_name", rule_group_name)
        if disabled_rules is not None:
            _setter("disabled_rules", disabled_rules)
        if rules is not None:
            _setter("rules", rules)

    @property
    @pulumi.getter(name="ruleGroupName")
    def rule_group_name(self) -> str:
        """
        The name of the Rule Group. Possible values are `BadBots`, `crs_20_protocol_violations`, `crs_21_protocol_anomalies`, `crs_23_request_limits`, `crs_30_http_policy`, `crs_35_bad_robots`, `crs_40_generic_attacks`, `crs_41_sql_injection_attacks`, `crs_41_xss_attacks`, `crs_42_tight_security`, `crs_45_trojans`, `General`, `GoodBots`, `Known-CVEs`, `REQUEST-911-METHOD-ENFORCEMENT`, `REQUEST-913-SCANNER-DETECTION`, `REQUEST-920-PROTOCOL-ENFORCEMENT`, `REQUEST-921-PROTOCOL-ATTACK`, `REQUEST-930-APPLICATION-ATTACK-LFI`, `REQUEST-931-APPLICATION-ATTACK-RFI`, `REQUEST-932-APPLICATION-ATTACK-RCE`, `REQUEST-933-APPLICATION-ATTACK-PHP`, `REQUEST-941-APPLICATION-ATTACK-XSS`, `REQUEST-942-APPLICATION-ATTACK-SQLI`, `REQUEST-943-APPLICATION-ATTACK-SESSION-FIXATION`, `REQUEST-944-APPLICATION-ATTACK-JAVA` and `UnknownBots`.
        """
        return pulumi.get(self, "rule_group_name")

    @property
    @pulumi.getter(name="disabledRules")
    def disabled_rules(self) -> Optional[Sequence[str]]:
        warnings.warn("""`disabled_rules` will be removed in favour of the `rule` property in version 4.0 of the AzureRM Provider.""", DeprecationWarning)
        pulumi.log.warn("""disabled_rules is deprecated: `disabled_rules` will be removed in favour of the `rule` property in version 4.0 of the AzureRM Provider.""")

        return pulumi.get(self, "disabled_rules")

    @property
    @pulumi.getter
    def rules(self) -> Optional[Sequence['outputs.PolicyManagedRulesManagedRuleSetRuleGroupOverrideRule']]:
        """
        One or more `rule` block defined below.
        """
        return pulumi.get(self, "rules")


@pulumi.output_type
class PolicyManagedRulesManagedRuleSetRuleGroupOverrideRule(dict):
    def __init__(__self__, *,
                 id: str,
                 action: Optional[str] = None,
                 enabled: Optional[bool] = None):
        """
        :param str id: Identifier for the managed rule.
        :param str action: Describes the override action to be applied when rule matches. Possible values are `Allow`, `AnomalyScoring`, `Block` and `Log`.
        :param bool enabled: Describes if the managed rule is in enabled state or disabled state.
        """
        PolicyManagedRulesManagedRuleSetRuleGroupOverrideRule._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            id=id,
            action=action,
            enabled=enabled,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             id: str,
             action: Optional[str] = None,
             enabled: Optional[bool] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):

        _setter("id", id)
        if action is not None:
            _setter("action", action)
        if enabled is not None:
            _setter("enabled", enabled)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        Identifier for the managed rule.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def action(self) -> Optional[str]:
        """
        Describes the override action to be applied when rule matches. Possible values are `Allow`, `AnomalyScoring`, `Block` and `Log`.
        """
        return pulumi.get(self, "action")

    @property
    @pulumi.getter
    def enabled(self) -> Optional[bool]:
        """
        Describes if the managed rule is in enabled state or disabled state.
        """
        return pulumi.get(self, "enabled")


@pulumi.output_type
class PolicyPolicySettings(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "fileUploadLimitInMb":
            suggest = "file_upload_limit_in_mb"
        elif key == "logScrubbing":
            suggest = "log_scrubbing"
        elif key == "maxRequestBodySizeInKb":
            suggest = "max_request_body_size_in_kb"
        elif key == "requestBodyCheck":
            suggest = "request_body_check"
        elif key == "requestBodyInspectLimitInKb":
            suggest = "request_body_inspect_limit_in_kb"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in PolicyPolicySettings. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        PolicyPolicySettings.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        PolicyPolicySettings.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 enabled: Optional[bool] = None,
                 file_upload_limit_in_mb: Optional[int] = None,
                 log_scrubbing: Optional['outputs.PolicyPolicySettingsLogScrubbing'] = None,
                 max_request_body_size_in_kb: Optional[int] = None,
                 mode: Optional[str] = None,
                 request_body_check: Optional[bool] = None,
                 request_body_inspect_limit_in_kb: Optional[int] = None):
        """
        :param bool enabled: Describes if the policy is in enabled state or disabled state. Defaults to `true`.
        :param int file_upload_limit_in_mb: The File Upload Limit in MB. Accepted values are in the range `1` to `4000`. Defaults to `100`.
        :param 'PolicyPolicySettingsLogScrubbingArgs' log_scrubbing: One `log_scrubbing` block as defined below.
        :param int max_request_body_size_in_kb: The Maximum Request Body Size in KB. Accepted values are in the range `8` to `2000`. Defaults to `128`.
        :param str mode: Describes if it is in detection mode or prevention mode at the policy level. Valid values are `Detection` and `Prevention`. Defaults to `Prevention`.
        :param bool request_body_check: Is Request Body Inspection enabled? Defaults to `true`.
        :param int request_body_inspect_limit_in_kb: Specifies the maximum request body inspection limit in KB for the Web Application Firewall. Defaults to `128`.
        """
        PolicyPolicySettings._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            enabled=enabled,
            file_upload_limit_in_mb=file_upload_limit_in_mb,
            log_scrubbing=log_scrubbing,
            max_request_body_size_in_kb=max_request_body_size_in_kb,
            mode=mode,
            request_body_check=request_body_check,
            request_body_inspect_limit_in_kb=request_body_inspect_limit_in_kb,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             enabled: Optional[bool] = None,
             file_upload_limit_in_mb: Optional[int] = None,
             log_scrubbing: Optional['outputs.PolicyPolicySettingsLogScrubbing'] = None,
             max_request_body_size_in_kb: Optional[int] = None,
             mode: Optional[str] = None,
             request_body_check: Optional[bool] = None,
             request_body_inspect_limit_in_kb: Optional[int] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'fileUploadLimitInMb' in kwargs:
            file_upload_limit_in_mb = kwargs['fileUploadLimitInMb']
        if 'logScrubbing' in kwargs:
            log_scrubbing = kwargs['logScrubbing']
        if 'maxRequestBodySizeInKb' in kwargs:
            max_request_body_size_in_kb = kwargs['maxRequestBodySizeInKb']
        if 'requestBodyCheck' in kwargs:
            request_body_check = kwargs['requestBodyCheck']
        if 'requestBodyInspectLimitInKb' in kwargs:
            request_body_inspect_limit_in_kb = kwargs['requestBodyInspectLimitInKb']

        if enabled is not None:
            _setter("enabled", enabled)
        if file_upload_limit_in_mb is not None:
            _setter("file_upload_limit_in_mb", file_upload_limit_in_mb)
        if log_scrubbing is not None:
            _setter("log_scrubbing", log_scrubbing)
        if max_request_body_size_in_kb is not None:
            _setter("max_request_body_size_in_kb", max_request_body_size_in_kb)
        if mode is not None:
            _setter("mode", mode)
        if request_body_check is not None:
            _setter("request_body_check", request_body_check)
        if request_body_inspect_limit_in_kb is not None:
            _setter("request_body_inspect_limit_in_kb", request_body_inspect_limit_in_kb)

    @property
    @pulumi.getter
    def enabled(self) -> Optional[bool]:
        """
        Describes if the policy is in enabled state or disabled state. Defaults to `true`.
        """
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter(name="fileUploadLimitInMb")
    def file_upload_limit_in_mb(self) -> Optional[int]:
        """
        The File Upload Limit in MB. Accepted values are in the range `1` to `4000`. Defaults to `100`.
        """
        return pulumi.get(self, "file_upload_limit_in_mb")

    @property
    @pulumi.getter(name="logScrubbing")
    def log_scrubbing(self) -> Optional['outputs.PolicyPolicySettingsLogScrubbing']:
        """
        One `log_scrubbing` block as defined below.
        """
        return pulumi.get(self, "log_scrubbing")

    @property
    @pulumi.getter(name="maxRequestBodySizeInKb")
    def max_request_body_size_in_kb(self) -> Optional[int]:
        """
        The Maximum Request Body Size in KB. Accepted values are in the range `8` to `2000`. Defaults to `128`.
        """
        return pulumi.get(self, "max_request_body_size_in_kb")

    @property
    @pulumi.getter
    def mode(self) -> Optional[str]:
        """
        Describes if it is in detection mode or prevention mode at the policy level. Valid values are `Detection` and `Prevention`. Defaults to `Prevention`.
        """
        return pulumi.get(self, "mode")

    @property
    @pulumi.getter(name="requestBodyCheck")
    def request_body_check(self) -> Optional[bool]:
        """
        Is Request Body Inspection enabled? Defaults to `true`.
        """
        return pulumi.get(self, "request_body_check")

    @property
    @pulumi.getter(name="requestBodyInspectLimitInKb")
    def request_body_inspect_limit_in_kb(self) -> Optional[int]:
        """
        Specifies the maximum request body inspection limit in KB for the Web Application Firewall. Defaults to `128`.
        """
        return pulumi.get(self, "request_body_inspect_limit_in_kb")


@pulumi.output_type
class PolicyPolicySettingsLogScrubbing(dict):
    def __init__(__self__, *,
                 enabled: Optional[bool] = None,
                 rules: Optional[Sequence['outputs.PolicyPolicySettingsLogScrubbingRule']] = None):
        """
        :param bool enabled: Whether the log scrubbing is enabled or disabled. Defaults to `true`.
        :param Sequence['PolicyPolicySettingsLogScrubbingRuleArgs'] rules: One or more `scrubbing_rule` as define below.
        """
        PolicyPolicySettingsLogScrubbing._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            enabled=enabled,
            rules=rules,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             enabled: Optional[bool] = None,
             rules: Optional[Sequence['outputs.PolicyPolicySettingsLogScrubbingRule']] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):

        if enabled is not None:
            _setter("enabled", enabled)
        if rules is not None:
            _setter("rules", rules)

    @property
    @pulumi.getter
    def enabled(self) -> Optional[bool]:
        """
        Whether the log scrubbing is enabled or disabled. Defaults to `true`.
        """
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter
    def rules(self) -> Optional[Sequence['outputs.PolicyPolicySettingsLogScrubbingRule']]:
        """
        One or more `scrubbing_rule` as define below.
        """
        return pulumi.get(self, "rules")


@pulumi.output_type
class PolicyPolicySettingsLogScrubbingRule(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "matchVariable":
            suggest = "match_variable"
        elif key == "selectorMatchOperator":
            suggest = "selector_match_operator"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in PolicyPolicySettingsLogScrubbingRule. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        PolicyPolicySettingsLogScrubbingRule.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        PolicyPolicySettingsLogScrubbingRule.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 match_variable: str,
                 enabled: Optional[bool] = None,
                 selector: Optional[str] = None,
                 selector_match_operator: Optional[str] = None):
        """
        :param str match_variable: The name of the Match Variable. Possible values: `RequestArgKeys`, `RequestArgNames`, `RequestArgValues`, `RequestCookieKeys`, `RequestCookieNames`, `RequestCookieValues`, `RequestHeaderKeys`, `RequestHeaderNames`, `RequestHeaderValues`.
        :param bool enabled: Describes if the managed rule is in enabled state or disabled state.
        :param str selector: Describes field of the matchVariable collection.
        :param str selector_match_operator: Describes operator to be matched. Possible values: `Contains`, `EndsWith`, `Equals`, `EqualsAny`, `StartsWith`.
        """
        PolicyPolicySettingsLogScrubbingRule._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            match_variable=match_variable,
            enabled=enabled,
            selector=selector,
            selector_match_operator=selector_match_operator,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             match_variable: str,
             enabled: Optional[bool] = None,
             selector: Optional[str] = None,
             selector_match_operator: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'matchVariable' in kwargs:
            match_variable = kwargs['matchVariable']
        if 'selectorMatchOperator' in kwargs:
            selector_match_operator = kwargs['selectorMatchOperator']

        _setter("match_variable", match_variable)
        if enabled is not None:
            _setter("enabled", enabled)
        if selector is not None:
            _setter("selector", selector)
        if selector_match_operator is not None:
            _setter("selector_match_operator", selector_match_operator)

    @property
    @pulumi.getter(name="matchVariable")
    def match_variable(self) -> str:
        """
        The name of the Match Variable. Possible values: `RequestArgKeys`, `RequestArgNames`, `RequestArgValues`, `RequestCookieKeys`, `RequestCookieNames`, `RequestCookieValues`, `RequestHeaderKeys`, `RequestHeaderNames`, `RequestHeaderValues`.
        """
        return pulumi.get(self, "match_variable")

    @property
    @pulumi.getter
    def enabled(self) -> Optional[bool]:
        """
        Describes if the managed rule is in enabled state or disabled state.
        """
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter
    def selector(self) -> Optional[str]:
        """
        Describes field of the matchVariable collection.
        """
        return pulumi.get(self, "selector")

    @property
    @pulumi.getter(name="selectorMatchOperator")
    def selector_match_operator(self) -> Optional[str]:
        """
        Describes operator to be matched. Possible values: `Contains`, `EndsWith`, `Equals`, `EqualsAny`, `StartsWith`.
        """
        return pulumi.get(self, "selector_match_operator")


